package galinhasscenes;


import java.util.ArrayList;
import javafx.animation.ParallelTransition;
import javafx.animation.PauseTransition;
import javafx.animation.RotateTransition;
import javafx.animation.SequentialTransition;
import javafx.animation.Timeline;
import javafx.animation.TranslateTransition;
import javafx.application.Application;
import static javafx.application.Application.launch;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.Pane;
import javafx.scene.layout.StackPane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Ellipse;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import javafx.scene.effect.Effect;
import javafx.scene.effect.DropShadow;
import javafx.scene.layout.Border;
import javafx.util.Duration;
 
public class GalinhasScenes extends Application { 
        
    public ArrayList<String> producerCode, consumerCode, initCode;
    public int mutex, full, empty, step, language;
    
    public Text tMutex, tMutexN, tEmpty, tEmptyN, tFull, tFullN;
    
    public Button nextstep, playthis, reset, nowuseeme;
    
    public StackPane table1_0, table1_1, table1_2, table1_3, table1_4, table1_5, table1_6;
    public StackPane table2_0, table2_1, table2_2, table2_3, table2_4, table2_5, table2_6;
    
    public ImageView zView, zFarmerView, background, myChickenView, pChickenView, sChickenView, farmerView, sFarmerView, pFarmerView;
    
    public Ellipse nest, egg, egg0,egg1,egg2,egg3;
    
    public GalinhasScenes(Stage stage, int lang){
        language = lang;
        start(stage);
    }
    
    @Override public void start(Stage stage) {
        
        mutex = 1;
        full = 0;
        empty = 4;
        
        //language = 1;
        // 0 = PT-BR
        // 1 = EN
        
        step = 0;
                 
        /*------------------------------------------ Cenário ----------------------------------------------*/
        
        // Fazenda
        Pane root = new Pane();
        background = new ImageView();
        background.setImage(new Image("/img3/farm.jpg"));
        background.setFitHeight(462);
        background.setFitWidth(1000);
        root.getChildren().add(background);
        Scene scene = new Scene(root, 500, 500, Color.LIGHTBLUE);
        stage.setScene(scene); 
        stage.setWidth(1006);
        stage.setHeight(491);     
        
        // Galinha acordada      
        myChickenView = new ImageView();
        myChickenView.setImage(new Image("/img3/my_chicken.png"));
        myChickenView.setFitHeight(300);
        myChickenView.setFitWidth(300);
        myChickenView.setX(58);
        myChickenView.setY(270);
        myChickenView.setVisible(true);        
    
        // Galinha botando ovo
        pChickenView = new ImageView();
        pChickenView.setImage(new Image("/img3/putting_chicken.png"));
        pChickenView.setFitHeight(300);
        pChickenView.setFitWidth(300);
        pChickenView.setX(0);
        pChickenView.setY(192);
        pChickenView.setVisible(false);
        
        // Galinha dormindo
        sChickenView = new ImageView();
        sChickenView.setImage(new Image("/img3/sleepy_chicken.png"));
        sChickenView.setFitHeight(300);
        sChickenView.setFitWidth(300);
        sChickenView.setX(20);
        sChickenView.setY(300);
        sChickenView.setVisible(false);        
        
        // Ninho
        nest = new Ellipse();
        nest.setCenterX(42.0f);
        nest.setCenterY(350.0f);
        nest.setRadiusX(45.0f);
        nest.setRadiusY(20.0f);        
        nest.setFill(Color.TAN);
        nest.setTranslateX(200);
        nest.setTranslateY(75);
        
        // Ovo usado na animação       
        egg = new Ellipse();
        egg.setCenterX(75.0f);
        egg.setCenterY(180.0f);
        egg.setRadiusX(7.0f);
        egg.setRadiusY(10.0f);        
        egg.setFill(Color.WHITE);
        egg.setTranslateX(50);
        egg.setTranslateY(270);
        egg.setVisible(false);
        
        // Primeiro ovo que cai no ninho
        egg0 = new Ellipse();
        egg0.setCenterX(75.0f);
        egg0.setCenterY(160.0f);
        egg0.setRadiusX(7.0f);
        egg0.setRadiusY(10.0f);        
        egg0.setFill(Color.WHITE);
        egg0.setTranslateX(176);
        egg0.setTranslateY(270);
        egg0.setVisible(false);
        
        // Segundo ovo que cai no ninho
        egg1 = new Ellipse();
        egg1.setCenterX(75.0f);
        egg1.setCenterY(160.0f);
        egg1.setRadiusX(7.0f);
        egg1.setRadiusY(10.0f);        
        egg1.setFill(Color.WHITE);
        egg1.setTranslateX(160);
        egg1.setTranslateY(270);
        egg1.setVisible(false);
        
        // Terceiro ovo que cai no ninho
        egg2 = new Ellipse();
        egg2.setCenterX(75.0f);
        egg2.setCenterY(160.0f);
        egg2.setRadiusX(7.0f);
        egg2.setRadiusY(10.0f);        
        egg2.setFill(Color.WHITE);
        egg2.setTranslateX(142);
        egg2.setTranslateY(270);
        egg2.setVisible(false);
        
        // Quarto ovo que cai no ovo
        egg3 = new Ellipse();
        egg3.setCenterX(75.0f);
        egg3.setCenterY(160.0f);
        egg3.setRadiusX(7.0f);
        egg3.setRadiusY(10.0f);        
        egg3.setFill(Color.WHITE);
        egg3.setTranslateX(192);
        egg3.setTranslateY(270);
        egg3.setVisible(false);
        
        // Soneca usada na animação da galinha dormindo
        Image z = new Image("/img3/zzz.png", 300, 300, false, false);
        zView = new ImageView(z);
        zView.setX(40);
        zView.setY(270);
        zView.setVisible(false); 
        
        // Soneca usada na animação do fazendeiro dormindo
        Image zFarmer = new Image("/img3/zzz.png", 300, 300, false, false);
        zFarmerView = new ImageView(zFarmer);
        zFarmerView.setX(340);
        zFarmerView.setY(148);
        zFarmerView.setVisible(false); 
        
        // Fazendeiro acordado
        Image farmer = new Image("/img3/farmer.png", 410, 300, false, false);
        farmerView = new ImageView(farmer);
        farmerView.setX(200);
        farmerView.setY(140);
        farmerView.setVisible(true);
        
        // Fazendeiro dormindo
        Image sFarmer = new Image("/img3/sleepy_farmer.png", 590, 328, false, false);
        sFarmerView = new ImageView(sFarmer);
        sFarmerView.setX(130);
        sFarmerView.setY(130);
        sFarmerView.setVisible(false);
        
        // Fazendeiro pegando ovo
        Image pFarmer = new Image("/img3/picking_farmer.png", 440, 300, false, false);
        pFarmerView = new ImageView(pFarmer);
        pFarmerView.setX(130);
        pFarmerView.setY(140);
        pFarmerView.setVisible(false);
 
        root.getChildren().addAll(myChickenView, nest, egg, pChickenView, sChickenView, egg0, egg1, egg2, egg3, zView, zFarmerView, farmerView, sFarmerView, pFarmerView); // adiciona todos elementos na cena
        
        stage.show();
        
        /*----------------------------------- Códigos e Tabelas ---------------------------------------*/

        // Produtor
        
        
        producerCode = new ArrayList<>();
        if(language == 1){
        producerCode.add("1   producer( ){");
        producerCode.add("2   \tint item;");
        producerCode.add("3   \twhile (TRUE) {");
        producerCode.add("4   \t\titem = create_item( );");
        producerCode.add("5   \t\tdown(empty);");
        producerCode.add("6   \t\tdown(mutex);");
        producerCode.add("7   \t\tinsert_item(item);");
        producerCode.add("8   \t\tup(mutex);");
        producerCode.add("9   \t\tup(full);");
        producerCode.add("10  \t}");
        producerCode.add("11  }");
        }
        else{
        producerCode.add("1   produtor( ){");
        producerCode.add("2   \tint item;");
        producerCode.add("3   \twhile (TRUE) {");
        producerCode.add("4   \t\titem = criar_item( );");
        producerCode.add("5   \t\tdown(empty);");
        producerCode.add("6   \t\tdown(mutex);");
        producerCode.add("7   \t\tinsert_item(item);");
        producerCode.add("8   \t\tup(mutex);");
        producerCode.add("9   \t\tup(full);");
        producerCode.add("10  \t}");
        producerCode.add("11  }");            
            
        }
            
        table1_0 = new StackPane();
        ImageView imageTable1_0 = new ImageView("/img3/table1init.png");        
        table1_0.getChildren().add(imageTable1_0);
        table1_0.setTranslateY(170); 
        table1_0.setTranslateX(510);
        
        table1_1 = new StackPane();
        ImageView imageTable1_1 = new ImageView("/img3/table1_1.png");        
        table1_1.getChildren().add(imageTable1_1);
        table1_1.setTranslateY(170); 
        table1_1.setTranslateX(510);
        
        table1_2 = new StackPane();
        ImageView imageTable1_2 = new ImageView("/img3/table1_2.png");        
        table1_2.getChildren().add(imageTable1_2);
        table1_2.setTranslateY(170); 
        table1_2.setTranslateX(510);
        
        table1_3 = new StackPane();
        ImageView imageTable1_3 = new ImageView("/img3/table1_3.png");        
        table1_3.getChildren().add(imageTable1_3);
        table1_3.setTranslateY(170); 
        table1_3.setTranslateX(510);
        
        table1_4 = new StackPane();
        ImageView imageTable1_4 = new ImageView("/img3/table1_4.png");        
        table1_4.getChildren().add(imageTable1_4);
        table1_4.setTranslateY(170); 
        table1_4.setTranslateX(510);
        
        table1_5 = new StackPane();
        ImageView imageTable1_5 = new ImageView("/img3/table1_5.png");        
        table1_5.getChildren().add(imageTable1_5);
        table1_5.setTranslateY(170); 
        table1_5.setTranslateX(510);        
        
        table1_6 = new StackPane();
        ImageView imageTable1_6 = new ImageView("/img3/table1_6.png");        
        table1_6.getChildren().add(imageTable1_6);
        table1_6.setTranslateY(170); 
        table1_6.setTranslateX(510);
        
        Text tProducer = new Text ();
        if(language == 1) tProducer.setText("Producer");
        else tProducer.setText("Produtor");
        tProducer.setFont(Font.font(null, FontWeight.BOLD, 20));
        tProducer.setTranslateX(530);
        tProducer.setTranslateY(165);
        tProducer.setFill(Color.DARKSLATEGREY);  
        
        ArrayList<Text> dataProducer = new ArrayList<>();
        
        int textX = 0;
        
        for (int i = 0; i < 11; i++) {
            dataProducer.add(new Text (producerCode.get(i)));
            
            dataProducer.get(i).setTranslateX(513);
            dataProducer.get(i).setTranslateY(190 + textX);
            dataProducer.get(i).setFont(Font.font(null, FontWeight.NORMAL, 15));
            dataProducer.get(i).setFill(Color.rgb(15, 15, 15));  

            textX += 24;
  
        }
        
        // Consumidor
        consumerCode = new ArrayList<>();
        if(language == 1){
        consumerCode.add("1   consumer( ){");
        consumerCode.add("2   \tint item;");
        consumerCode.add("3   \twhile (TRUE) {");
        consumerCode.add("4   \t\tdown(full);");
        consumerCode.add("5   \t\tdown(mutex);");
        consumerCode.add("6   \t\titem = remove_item( );");
        consumerCode.add("7   \t\tup(mutex);");
        consumerCode.add("8   \t\tup(empty);");
        consumerCode.add("9   \t\tprocess_item(item);");
        consumerCode.add("10  \t}");
        consumerCode.add("11  }");    
        
        stage.setTitle("Producer/Consumer Example");  
        
        }
        else{
        consumerCode.add("1   consumidor( ){");
        consumerCode.add("2   \tint item;");
        consumerCode.add("3   \twhile (TRUE) {");
        consumerCode.add("4   \t\tdown(full);");
        consumerCode.add("5   \t\tdown(mutex);");
        consumerCode.add("6   \t\titem = remover_item( );");
        consumerCode.add("7   \t\tup(mutex);");
        consumerCode.add("8   \t\tup(empty);");
        consumerCode.add("9   \t\tprocessar_item(item);");
        consumerCode.add("10  \t}");
        consumerCode.add("11  }");  
        
        stage.setTitle("Exemplo de Produtor/Consumidor");  
        }
        table2_0 = new StackPane();
        ImageView imageTable2_0 = new ImageView("/img3/table1init.png");        
        table2_0.getChildren().add(imageTable2_0);
        table2_0.setTranslateY(170); 
        table2_0.setTranslateX(750);
        
        table2_1 = new StackPane();
        ImageView imageTable2_1 = new ImageView("/img3/table1_1.png");        
        table2_1.getChildren().add(imageTable2_1);
        table2_1.setTranslateY(170); 
        table2_1.setTranslateX(750);
        
        table2_2 = new StackPane();
        ImageView imageTable2_2 = new ImageView("/img3/table1_2.png");        
        table2_2.getChildren().add(imageTable2_2);
        table2_2.setTranslateY(170); 
        table2_2.setTranslateX(750);
        
        table2_3 = new StackPane();
        ImageView imageTable2_3 = new ImageView("/img3/table1_3.png");        
        table2_3.getChildren().add(imageTable2_3);
        table2_3.setTranslateY(170); 
        table2_3.setTranslateX(750);
        
        table2_4 = new StackPane();
        ImageView imageTable2_4 = new ImageView("/img3/table1_4.png");        
        table2_4.getChildren().add(imageTable2_4);
        table2_4.setTranslateY(170); 
        table2_4.setTranslateX(750);
        
        table2_5 = new StackPane();
        ImageView imageTable2_5 = new ImageView("/img3/table1_5.png");        
        table2_5.getChildren().add(imageTable2_5);
        table2_5.setTranslateY(170); 
        table2_5.setTranslateX(750);        
        
        table2_6 = new StackPane();
        ImageView imageTable2_6 = new ImageView("/img3/table1_6.png");        
        table2_6.getChildren().add(imageTable2_6);
        table2_6.setTranslateY(170); 
        table2_6.setTranslateX(750);
         
        Text tConsumer = new Text ();
        if(language == 1) tConsumer.setText("Consumer");
        else tConsumer.setText("Consumidor");
        tConsumer.setFont(Font.font(null, FontWeight.BOLD, 20));
        tConsumer.setTranslateX(770);
        tConsumer.setTranslateY(165);
        tConsumer.setFill(Color.DARKSLATEGREY);  
        
        ArrayList<Text> dataConsumer = new ArrayList<>();
        
        textX = 0;
        
        for (int i = 0; i < 11; i++) {
            dataConsumer.add(new Text (consumerCode.get(i)));
            dataConsumer.get(i).setTranslateX(753);
            dataConsumer.get(i).setTranslateY(190 + textX);
            dataConsumer.get(i).setFont(Font.font(null, FontWeight.NORMAL, 15));
            dataConsumer.get(i).setFill(Color.rgb(15, 15, 15));  

            textX += 24;
  
        }
        
        table1_1.setVisible(false);
        table1_2.setVisible(false);
        table1_3.setVisible(false);
        table1_4.setVisible(false);
        table1_5.setVisible(false);
        table1_6.setVisible(false);

        table2_1.setVisible(false);
        table2_2.setVisible(false);
        table2_3.setVisible(false);
        table2_4.setVisible(false);
        table2_5.setVisible(false);
        table2_6.setVisible(false);
        
        // Semaforos
        
        tMutex = new Text ("Mutex");
        tMutex.setFont(Font.font(null, FontWeight.BOLD, 20));
        tMutex.setTranslateX(670);
        tMutex.setTranslateY(50);
        tMutex.setFill(Color.DARKSLATEGREY); 
        
        tMutexN = new Text ();
        tMutexN.setFont(Font.font(null, FontWeight.NORMAL, 20));
        tMutexN.setTranslateX(770);
        tMutexN.setTranslateY(50);
        tMutexN.setFill(Color.DARKSLATEGREY); 
        tMutexN.setText(Integer.toString(mutex));
        
        tEmpty = new Text ();
        tEmpty.setText("Empty"); 
        tEmpty.setFont(Font.font(null, FontWeight.BOLD, 20));
        tEmpty.setTranslateX(670);
        tEmpty.setTranslateY(80);
        tEmpty.setFill(Color.DARKSLATEGREY);
        
        tEmptyN = new Text ();
        tEmptyN.setFont(Font.font(null, FontWeight.NORMAL, 20));
        tEmptyN.setTranslateX(770);
        tEmptyN.setTranslateY(80);
        tEmptyN.setFill(Color.DARKSLATEGREY); 
        tEmptyN.setText(Integer.toString(empty));
        
        tFull = new Text ();
        tFull.setText("Full"); 
        tFull.setFont(Font.font(null, FontWeight.BOLD, 20));
        tFull.setTranslateX(670);
        tFull.setTranslateY(110);
        tFull.setFill(Color.DARKSLATEGREY); 
        
        tFullN = new Text ();
        tFullN.setFont(Font.font(null, FontWeight.NORMAL, 20));
        tFullN.setTranslateX(770);
        tFullN.setTranslateY(110);
        tFullN.setFill(Color.DARKSLATEGREY); 
        tFullN.setText(Integer.toString(full));
        
        // Botão
        nextstep = new Button();
        if(language == 1) nextstep.setText("Step by step");
        else nextstep.setText("Passo a passo"); 
        nextstep.setTranslateX(510);
        nextstep.setTranslateY(35);
        
        playthis = new Button();
        if(language == 1) playthis.setText("Play!");
        else playthis.setText("Rodar!"); 
        playthis.setTranslateX(510);
        playthis.setTranslateY(5);    
        
        reset = new Button();
        if(language == 1) reset.setText("Restart");
        else reset.setText("Reiniciar"); 
        reset.setTranslateX(510);
        reset.setTranslateY(65);   
        reset.setDisable(true);
        
        nowuseeme = new Button("Info");
        nowuseeme.setTranslateX(945);
        nowuseeme.setTranslateY(5); 
              
        nowuseeme.setFocusTraversable(false);
        
        // info
        DropShadow infoS = new DropShadow();
                
        Text infoProducer = new Text ();
        if(language == 1) infoProducer.setText("Producer");
        else infoProducer.setText("Produtor");
        infoProducer.setFont(Font.font(null, FontWeight.BOLD, 30));
        infoProducer.setTranslateX(10);
        infoProducer.setTranslateY(290);
        infoProducer.setEffect(infoS);
        infoProducer.setFill(Color.GOLD);  
        infoProducer.setVisible(false);
        
        Text infoConsumer = new Text ();
        if(language == 1) infoConsumer.setText("Consumer");
        else infoConsumer.setText("Consumidor");
        infoConsumer.setFont(Font.font(null, FontWeight.BOLD, 30));
        infoConsumer.setTranslateX(320);
        infoConsumer.setTranslateY(160);
        infoConsumer.setEffect(infoS);
        infoConsumer.setFill(Color.CYAN);  
        infoConsumer.setVisible(false);
        
        Text infoBuffer = new Text ("Buffer\n(max = 4)");
        infoBuffer.setFont(Font.font(null, FontWeight.BOLD, 25));
        infoBuffer.setTranslateX(200);
        infoBuffer.setTranslateY(350);
        infoBuffer.setEffect(infoS);
        infoBuffer.setFill(Color.WHITE);  
        infoBuffer.setVisible(false);  
        
        Text infoSemaphores = new Text ();
        if(language == 1) infoSemaphores.setText("Semaphores");
        else infoSemaphores.setText("Semáforos");
        infoSemaphores.setFont(Font.font(null, FontWeight.BOLD, 20));
        infoSemaphores.setTranslateX(670);
        infoSemaphores.setTranslateY(20);
        infoSemaphores.setEffect(infoS);
        infoSemaphores.setFill(Color.WHITE);  
        infoSemaphores.setVisible(false);  

        // ...
        root.getChildren().addAll(table1_0, table1_1, table1_2, table1_3, table1_4, table1_5, table1_6);
        root.getChildren().addAll(table2_0, table2_1, table2_2, table2_3, table2_4, table2_5, table2_6);
        root.getChildren().addAll(tProducer, tConsumer, tMutex, tEmpty, tFull, tMutexN, tEmptyN, tFullN);
        root.getChildren().addAll(infoProducer, infoConsumer, infoBuffer, infoSemaphores);
        root.getChildren().addAll(nextstep, playthis, reset, nowuseeme);
        
        for (int i = 0; i < 11; i++) {
            root.getChildren().addAll(dataProducer.get(i), dataConsumer.get(i));
        }
        
        TranslateTransition init = new TranslateTransition(Duration.millis(1), myChickenView);
        init.setFromY(20);  
        init.play();
        
        nowuseeme.setOnMouseEntered(evt -> {   
            
            DropShadow shadow = new DropShadow();
            shadow.setColor(Color.YELLOW);
            shadow.setRadius(20.0);           
            nowuseeme.setEffect(shadow);
            
            infoProducer.setVisible(true);
            infoConsumer.setVisible(true);
            infoBuffer.setVisible(true);
            infoSemaphores.setVisible(true); 
            
    
        });

        nowuseeme.setOnMouseExited(evt -> {           
            
            nowuseeme.setEffect(null);
            
            infoProducer.setVisible(false);
            infoConsumer.setVisible(false);
            infoBuffer.setVisible(false);
            infoSemaphores.setVisible(false); 
    
        });
        
        nextstep.setOnAction(new EventHandler<ActionEvent>() {
                @Override
                public void handle(ActionEvent event) {
                    playthis.setDisable(true);
                    step++;
                    playThis();
                                   
                }
        }); 
        
        playthis.setOnAction(new EventHandler<ActionEvent>() {
                @Override
                public void handle(ActionEvent event) {
                    nextstep.setDisable(true);reset.setDisable(true);   
                    playthis.setDisable(true); 
                    playLoop();
                }
        });
        
        reset.setOnAction(new EventHandler<ActionEvent>() {
                @Override
                public void handle(ActionEvent event) {
                    playInit();
                }
        });
       
    }
    
    public void playInit(){
        
        egg.setVisible(false);
        egg1.setVisible(false);
        egg2.setVisible(false);
        egg3.setVisible(false);
        
        table1_1.setVisible(false);
        table1_2.setVisible(false);
        table1_3.setVisible(false);
        table1_4.setVisible(false);
        table1_5.setVisible(false);
        table1_6.setVisible(false);

        table2_1.setVisible(false);
        table2_2.setVisible(false);
        table2_3.setVisible(false);
        table2_4.setVisible(false);
        table2_5.setVisible(false);
        table2_6.setVisible(false);

        mutex = 1;
        full = 0;
        empty = 4;
        step = 0;
        
        tMutexN.setText(Integer.toString(mutex));
        tFullN.setText(Integer.toString(full));
        tEmptyN.setText(Integer.toString(empty));
        
        fullOff();
        mutexOff();
        emptyOff();
                
        reset.setDisable(true);
        nextstep.setDisable(false);
        if(language == 1) nextstep.setText("Step by step");
        else nextstep.setText("Passo a passo"); 
        playthis.setDisable(false);
        
        myChickenView.setTranslateX(0);
        myChickenView.setTranslateY(20);
        myChickenView.setVisible(true);   
    
        pChickenView.setVisible(false);
        sChickenView.setVisible(false);     

        egg.setTranslateX(50);
        egg.setTranslateY(270);
        egg.setVisible(false);

        egg0.setTranslateX(176);
        egg0.setTranslateY(270);
        egg0.setVisible(false);

        egg1.setTranslateX(160);
        egg1.setTranslateY(270);
        egg1.setVisible(false);

        egg2.setTranslateX(142);
        egg2.setTranslateY(270);
        egg2.setVisible(false);

        egg3.setTranslateX(192);
        egg3.setTranslateY(270);
        egg3.setVisible(false);

        zView.setTranslateX(0);
        zView.setTranslateY(0);
        zView.setVisible(false); 

        farmerView.setTranslateX(0);
        farmerView.setTranslateY(0);
        farmerView.setVisible(true);

        sFarmerView.setVisible(false);
        pFarmerView.setVisible(false);
        
        zFarmerView.setTranslateX(0);
        zFarmerView.setTranslateY(0);
        zFarmerView.setVisible(false); 
        

    }
    
    public void playLoop(){
        
        // fazendeiro tenta pegar ovo
        TranslateTransition translateFarmer1 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer1.setFromX(0);
        translateFarmer1.setToX(-60);
        
        SequentialTransition sequentialFarmer1 = new SequentialTransition();
        sequentialFarmer1.getChildren().addAll(translateFarmer1);
        sequentialFarmer1.play();       
        
        SequentialTransition sequentialDelayFarmer1 = new SequentialTransition(new PauseTransition(Duration.millis(3000)));
        
        sequentialDelayFarmer1.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){
                farmerView.setVisible(false);
                pFarmerView.setVisible(true);               
            }        
        });
        sequentialDelayFarmer1.play();        
        
        // Fazendeiro dorme
        TranslateTransition translateZ = new TranslateTransition(Duration.millis(1000), zFarmerView);
        translateZ.setToY(-10);
        translateZ.setToX(30);
        translateZ.setCycleCount(Timeline.INDEFINITE);
        
        SequentialTransition sequentialFarmer2 = new SequentialTransition(new PauseTransition(Duration.millis(5500)));
                       
        sequentialFarmer2.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                pFarmerView.setVisible(false);
                sFarmerView.setVisible(true);
                zFarmerView.setVisible(true);
                translateZ.play();
            }        
        });
        sequentialFarmer2.play();   
        
        /*------------------------------------------ Cena 2 ----------------------------------------------*/
        /* Retrata o que caso em que o fazendeiro(consumidor) Ã© acordado pela galinha(produtor)           */
        
        // Galinha bota ovo
        TranslateTransition translateChicken1 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken1.setFromY(20);
        translateChicken1.setToY(-50);        
        
        TranslateTransition translateEgg1 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg1.setFromY(160);
        translateEgg1.setToY(250);        
      
        RotateTransition rotateEgg1 = new RotateTransition(Duration.millis(2000), egg);
        rotateEgg1.setByAngle(360);
                        
        TranslateTransition translateEgg2 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg2.setFromX(50);
        translateEgg2.setToX(176);     

        ParallelTransition parallelEgg1 = new ParallelTransition();
        parallelEgg1.getChildren().addAll(translateEgg1, rotateEgg1, translateEgg2);
        
        SequentialTransition sequentialChicken = new SequentialTransition(new PauseTransition(Duration.millis(6800)), translateChicken1);
        sequentialChicken.play();
        
        sequentialChicken.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(false);
                pChickenView.setVisible(true);
                egg.setVisible(true);
                parallelEgg1.play();                
            }        
        });
        sequentialChicken.play();  
        
        TranslateTransition translateChicken2 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken2.setFromY(-50);
        translateChicken2.setToY(20);
        
        SequentialTransition sequentialChicken2 = new SequentialTransition(new PauseTransition(Duration.millis(8500)));
        
        sequentialChicken2.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(true);
                pChickenView.setVisible(false);       
                translateChicken2.play();
            }        
        });
        sequentialChicken2.play();  
        
        // Fazendeiro Ã© acordado
        SequentialTransition sequentialDelayFarmer2 = new SequentialTransition(new PauseTransition(Duration.millis(9800)));
        
        sequentialDelayFarmer2.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){ 
                zFarmerView.setVisible(false);
                sFarmerView.setVisible(false);
                pFarmerView.setVisible(true);
            }        
        });
        sequentialDelayFarmer2.play();
        
        TranslateTransition translateFarmer2 = new TranslateTransition(Duration.millis(800), farmerView);
        translateFarmer2.setFromX(-60);
        translateFarmer2.setToX(0);
        
        SequentialTransition sequentialFarmer3 = new SequentialTransition(new PauseTransition(Duration.millis(11500)));
        
        sequentialFarmer3.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                egg.setVisible(false);
                pFarmerView.setVisible(false);
                farmerView.setVisible(true);
                translateFarmer2.play();
            }        
        });
        sequentialFarmer3.play();  
        
       /*------------------------------------------ Cena 3 ----------------------------------------------*/
       /* Retrata o produtor apenas produzindo                                                                                                */
        
        // Galinha bota ovo
        TranslateTransition translateChicken3 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken3.setFromY(20);
        translateChicken3.setToY(-50);        
        
        TranslateTransition translateEgg3 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg3.setFromY(160);
        translateEgg3.setToY(250);        
      
        RotateTransition rotateEgg2 = new RotateTransition(Duration.millis(2000), egg);
        rotateEgg2.setByAngle(360);
                        
        TranslateTransition translateEgg4 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg4.setFromX(50);
        translateEgg4.setToX(176);     

        ParallelTransition parallelEgg2 = new ParallelTransition();
        parallelEgg2.getChildren().addAll(translateEgg3, rotateEgg2, translateEgg4);
        
        SequentialTransition sequentialChicken3 = new SequentialTransition(new PauseTransition(Duration.millis(12000)), translateChicken3);
        sequentialChicken3.play();
        
        sequentialChicken3.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(false);
                pChickenView.setVisible(true);
                egg.setVisible(true);                
                parallelEgg2.play();  
            }        
        });
        sequentialChicken3.play();
        
        TranslateTransition translateChicken4 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken4.setFromY(-50);
        translateChicken4.setToY(20);
        
        SequentialTransition sequentialChicken4 = new SequentialTransition(new PauseTransition(Duration.millis(13700)));
        
        sequentialChicken4.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(true);
                pChickenView.setVisible(false);
                translateChicken4.play();
                
                fullUp();
                emptyDown();
                fullOn();
            }        
        });
        sequentialChicken4.play(); 
        
        // Galinha bota ovo
        TranslateTransition translateChicken5 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken5.setFromY(20);
        translateChicken5.setToY(-50);        
        
        TranslateTransition translateEgg5 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg5.setFromY(160);
        translateEgg5.setToY(250);        
      
        RotateTransition rotateEgg3 = new RotateTransition(Duration.millis(2000), egg);
        rotateEgg3.setByAngle(360);
                        
        TranslateTransition translateEgg6 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg6.setFromX(50);
        translateEgg6.setToX(160);     

        ParallelTransition parallelEgg3 = new ParallelTransition();
        parallelEgg3.getChildren().addAll(translateEgg5, rotateEgg3, translateEgg6);
        
        SequentialTransition sequentialChicken5 = new SequentialTransition(new PauseTransition(Duration.millis(15000)), translateChicken5);
        sequentialChicken5.play();
        
        sequentialChicken5.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(false);
                pChickenView.setVisible(true);
                egg.setVisible(true); 
                egg0.setVisible(true);
                parallelEgg3.play();  
                fullUp();
                emptyDown();
                fullOn();
            }        
        });
        sequentialChicken5.play();
        
        TranslateTransition translateChicken7 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken7.setFromY(-50);
        translateChicken7.setToY(20);
        
        SequentialTransition sequentialChicken6 = new SequentialTransition(new PauseTransition(Duration.millis(16700)));
        
        sequentialChicken6.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){               
                myChickenView.setVisible(true);
                pChickenView.setVisible(false);       
                translateChicken7.play();
            }        
        });
        sequentialChicken6.play(); 
        
        /*------------------------------------------ Cena 4 ----------------------------------------------*/
        /* Retrata fazendeiro(consumidor) consumindo atÃ© todos os ovos acabarem, fazendo-o dormir         */
        
        // Fazendeiro tenta pegar ovo
        TranslateTransition translateFarmer3 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer3.setFromX(0);
        translateFarmer3.setToX(-60);  
        
        SequentialTransition sequentialDelayFarmer3 = new SequentialTransition(new PauseTransition(Duration.millis(18500)), translateFarmer3);
        
        sequentialDelayFarmer3.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){
                farmerView.setVisible(false);
                pFarmerView.setVisible(true);               
            }        
        });
        sequentialDelayFarmer3.play();    
        
        TranslateTransition translateFarmer4 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer4.setFromX(-60);
        translateFarmer4.setToX(0);
        
        SequentialTransition sequentialFarmer5 = new SequentialTransition(new PauseTransition(Duration.millis(21000)));
                
        sequentialFarmer5.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                egg.setVisible(false);
                pFarmerView.setVisible(false);
                farmerView.setVisible(true);
                translateFarmer4.play();
                fullDown();
                emptyUp();
                fullOn();
            }        
        });
        sequentialFarmer5.play();  
        
        // Fazendeiro tenta pegar ovo       
        TranslateTransition translateFarmer5 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer5.setFromX(0);
        translateFarmer5.setToX(-60);  
        
        SequentialTransition sequentialDelayFarmer4 = new SequentialTransition(new PauseTransition(Duration.millis(23500)), translateFarmer5);
        
        sequentialDelayFarmer4.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){
                farmerView.setVisible(false);
                pFarmerView.setVisible(true);               
            }        
        });
        sequentialDelayFarmer4.play();    
        
        TranslateTransition translateFarmer6 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer6.setFromX(-60);
        translateFarmer6.setToX(0);
        
        SequentialTransition sequentialFarmer6 = new SequentialTransition(new PauseTransition(Duration.millis(26000)));
                
        sequentialFarmer6.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                egg0.setVisible(false);
                pFarmerView.setVisible(false);
                farmerView.setVisible(true);
                translateFarmer4.play();
                fullDown();
                emptyUp();
                fullOn();
            }        
        });
        sequentialFarmer6.play();  
        
        // Fazendeiro tenta pegar ovo       
        TranslateTransition translateFarmer7 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer7.setFromX(0);
        translateFarmer7.setToX(-60);  
        
        SequentialTransition sequentialDelayFarmer5 = new SequentialTransition(new PauseTransition(Duration.millis(28500)), translateFarmer7);
        
        sequentialDelayFarmer5.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){
                farmerView.setVisible(false);
                pFarmerView.setVisible(true);               
            }        
        });
        sequentialDelayFarmer5.play(); 
        
        // Fazendeiro dorme       
        TranslateTransition translateZ2 = new TranslateTransition(Duration.millis(1000), zFarmerView);
        translateZ2.setToY(-10);
        translateZ2.setToX(30);
        translateZ2.setCycleCount(Timeline.INDEFINITE);
        
        SequentialTransition sequentialFarmer4 = new SequentialTransition(new PauseTransition(Duration.millis(31000)));
                       
        sequentialFarmer4.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                pFarmerView.setVisible(false);
                sFarmerView.setVisible(true);
                zFarmerView.setVisible(true);
                translateZ2.play();
            }        
        });
        sequentialFarmer4.play();
        
        /*------------------------------------------ Cena 5 ----------------------------------------------*/
        /* Retrata o fazendeiro(consumidor) sendo acordado pela galinha(produtor)                         */
        
        // Galinha bota ovo
        TranslateTransition translateChicken6 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken6.setFromY(20);
        translateChicken6.setToY(-50);        
        
        TranslateTransition translateEgg7 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg7.setFromY(160);
        translateEgg7.setToY(250);        
      
        RotateTransition rotateEgg4 = new RotateTransition(Duration.millis(2000), egg);
        rotateEgg4.setByAngle(360);
                        
        TranslateTransition translateEgg8 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg8.setFromX(50);
        translateEgg8.setToX(176);     

        ParallelTransition parallelEgg4 = new ParallelTransition();
        parallelEgg4.getChildren().addAll(translateEgg3, rotateEgg2, translateEgg4);
        
        SequentialTransition sequentialChicken7 = new SequentialTransition(new PauseTransition(Duration.millis(32300)), translateChicken6);
        sequentialChicken7.play();
        
        sequentialChicken7.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(false);
                pChickenView.setVisible(true);
                egg.setVisible(true);                
                parallelEgg4.play();                 
            }        
        });
        sequentialChicken7.play();
        
        TranslateTransition translateChicken8 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken2.setFromY(-50);
        translateChicken2.setToY(20);
        
        SequentialTransition sequentialChicken8 = new SequentialTransition(new PauseTransition(Duration.millis(34000)));
        
        sequentialChicken8.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){
                myChickenView.setVisible(true);
                pChickenView.setVisible(false);       
                translateChicken2.play();
            }        
        });
        sequentialChicken8.play();
        
        // Fazendeiro acorda
        SequentialTransition sequentialDelayFarmer6 = new SequentialTransition(new PauseTransition(Duration.millis(35300)));
        
        sequentialDelayFarmer6.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){ 
                zFarmerView.setVisible(false);
                sFarmerView.setVisible(false);
                pFarmerView.setVisible(true);
            }        
        });
        sequentialDelayFarmer6.play();
        
        TranslateTransition translateFarmer8 = new TranslateTransition(Duration.millis(800), farmerView);
        translateFarmer8.setFromX(-60);
        translateFarmer8.setToX(0);
        
        SequentialTransition sequentialFarmer7 = new SequentialTransition(new PauseTransition(Duration.millis(36000)));
        
        sequentialFarmer7.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                egg.setVisible(false);
                pFarmerView.setVisible(false);
                farmerView.setVisible(true);
                translateFarmer8.play();
            }        
        });
        sequentialFarmer7.play(); 
        
        /*------------------------------------------ Cena 6 ----------------------------------------------*/
        /* Retrata galinha(produtor) botando ovo atÃ© encher o ninho, fazendo-a dormir                     */
        
        // Galinha bota ovo
        TranslateTransition translateChicken9 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken9.setFromY(20);
        translateChicken9.setToY(-50);        
        
        TranslateTransition translateEgg9 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg9.setFromY(160);
        translateEgg9.setToY(250);        
      
        RotateTransition rotateEgg5 = new RotateTransition(Duration.millis(2000), egg);
        rotateEgg5.setByAngle(360);
                        
        TranslateTransition translateEgg10 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg10.setFromX(50);
        translateEgg10.setToX(176);     

        ParallelTransition parallelEgg5 = new ParallelTransition();
        parallelEgg5.getChildren().addAll(translateEgg9, rotateEgg5, translateEgg10);
        
        SequentialTransition sequentialChicken9 = new SequentialTransition(new PauseTransition(Duration.millis(37200)), translateChicken9);
        sequentialChicken9.play();
        
        sequentialChicken9.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(false);
                pChickenView.setVisible(true);
                egg.setVisible(true);                
                parallelEgg2.play();
            }        
        });
        sequentialChicken9.play();
        
        TranslateTransition translateChicken10 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken10.setFromY(-50);
        translateChicken10.setToY(20);
        
        SequentialTransition sequentialChicken10 = new SequentialTransition(new PauseTransition(Duration.millis(38900)));
        
        sequentialChicken10.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(true);
                pChickenView.setVisible(false);
                translateChicken10.play();
                fullUp();
                emptyDown();
                fullOn();
            }        
        });
        sequentialChicken10.play(); 
        
        // Galinha bota ovo
        TranslateTransition translateChicken11 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken11.setFromY(20);
        translateChicken11.setToY(-50);        
        
        TranslateTransition translateEgg11 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg11.setFromY(160);
        translateEgg11.setToY(250);        
      
        RotateTransition rotateEgg6 = new RotateTransition(Duration.millis(2000), egg);
        rotateEgg6.setByAngle(360);
                        
        TranslateTransition translateEgg12 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg12.setFromX(50);
        translateEgg12.setToX(160);     

        ParallelTransition parallelEgg6 = new ParallelTransition();
        parallelEgg6.getChildren().addAll(translateEgg11, rotateEgg6, translateEgg12);
        
        SequentialTransition sequentialChicken11 = new SequentialTransition(new PauseTransition(Duration.millis(39900)), translateChicken11);
        sequentialChicken11.play();
        
        sequentialChicken11.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(false);
                pChickenView.setVisible(true);
                egg.setVisible(true); 
                egg0.setVisible(true);
                parallelEgg3.play(); 
               
            }        
        });
        sequentialChicken11.play();
        
        TranslateTransition translateChicken12 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken12.setFromY(-50);
        translateChicken12.setToY(20);
        
        SequentialTransition sequentialChicken12 = new SequentialTransition(new PauseTransition(Duration.millis(41400)));
        
        sequentialChicken12.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){               
                myChickenView.setVisible(true);
                pChickenView.setVisible(false);       
                translateChicken12.play();
                fullUp();
                emptyDown();
                fullOn();
            }        
        });
        sequentialChicken12.play(); 
        
        // Galinha bota ovo
        TranslateTransition translateChicken13 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken13.setFromY(20);
        translateChicken13.setToY(-50);        
        
        TranslateTransition translateEgg13 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg13.setFromY(160);
        translateEgg13.setToY(250);        
      
        RotateTransition rotateEgg7 = new RotateTransition(Duration.millis(2000), egg);
        rotateEgg7.setByAngle(360);
                        
        TranslateTransition translateEgg14 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg14.setFromX(50);
        translateEgg14.setToX(142);     

        ParallelTransition parallelEgg7 = new ParallelTransition();
        parallelEgg7.getChildren().addAll(translateEgg13, rotateEgg7, translateEgg14);
        
        SequentialTransition sequentialChicken13 = new SequentialTransition(new PauseTransition(Duration.millis(42400)), translateChicken13);
        sequentialChicken13.play();
        
        sequentialChicken13.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(false);
                pChickenView.setVisible(true);
                egg.setVisible(true);  
                egg1.setVisible(true);
                parallelEgg7.play();               
            }        
        });
        sequentialChicken13.play();
        
        TranslateTransition translateChicken14 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken14.setFromY(-50);
        translateChicken14.setToY(20);
        
        SequentialTransition sequentialChicken14 = new SequentialTransition(new PauseTransition(Duration.millis(43900)));
        
        sequentialChicken14.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(true);
                pChickenView.setVisible(false);
                translateChicken14.play(); 
                fullUp();
                emptyDown();
                fullOn();
            }        
        });
        sequentialChicken14.play(); 
        
        // Galinha bota ovo
        TranslateTransition translateChicken15 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken15.setFromY(20);
        translateChicken15.setToY(-50);        
        
        TranslateTransition translateEgg15 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg15.setFromY(160);
        translateEgg15.setToY(250);        
      
        RotateTransition rotateEgg8 = new RotateTransition(Duration.millis(2000), egg);
        rotateEgg8.setByAngle(360);
                        
        TranslateTransition translateEgg16 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg16.setFromX(50);
        translateEgg16.setToX(192);     

        ParallelTransition parallelEgg8 = new ParallelTransition();
        parallelEgg8.getChildren().addAll(translateEgg15, rotateEgg8, translateEgg16);
        
        SequentialTransition sequentialChicken15 = new SequentialTransition(new PauseTransition(Duration.millis(44900)), translateChicken15);
        sequentialChicken15.play();
        
        sequentialChicken15.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(false);
                pChickenView.setVisible(true);
                egg.setVisible(true); 
                egg2.setVisible(true);
                parallelEgg8.play();                 
            }        
        });
        sequentialChicken15.play();
        
        TranslateTransition translateChicken16 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken16.setFromY(-50);
        translateChicken16.setToY(20);
        
        SequentialTransition sequentialChicken16 = new SequentialTransition(new PauseTransition(Duration.millis(46400)));
        
        sequentialChicken16.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){               
                myChickenView.setVisible(true);
                pChickenView.setVisible(false);       
                translateChicken16.play();
                fullUp();
                emptyDown();
                fullOn();
            }        
        });
        sequentialChicken16.play();
        
        // Galinha dorme
        TranslateTransition translateChickenZ = new TranslateTransition(Duration.millis(1000), zView);
        translateChickenZ.setToY(-10);
        translateChickenZ.setToX(30);
        translateChickenZ.setCycleCount(Timeline.INDEFINITE);
        
        SequentialTransition sequentialChicken17 = new SequentialTransition(new PauseTransition(Duration.millis(48000)));
        
        sequentialChicken17.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){
                zView.setVisible(true);
                myChickenView.setVisible(false);
                sChickenView.setVisible(true);
                translateChickenZ.play();
            }        
        });
        sequentialChicken17.play();
        
        /*------------------------------------------ Cena 7 ----------------------------------------------*/
        /* Retrata galinha(produtor) sendo acordada pelo fazendeiro(consumidor)                           */
        
        // Fazendeiro pega ovo
        TranslateTransition translateFarmer9 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer9.setFromX(0);
        translateFarmer9.setToX(-60);  
        
        SequentialTransition sequentialDelayFarmer7 = new SequentialTransition(new PauseTransition(Duration.millis(49500)), translateFarmer9);
        
        sequentialDelayFarmer7.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){
                farmerView.setVisible(false);
                pFarmerView.setVisible(true);               
            }        
        });
        sequentialDelayFarmer7.play(); 
        
        TranslateTransition translateFarmer10 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer10.setFromX(-60);
        translateFarmer10.setToX(0);
        
        SequentialTransition sequentialFarmer8 = new SequentialTransition(new PauseTransition(Duration.millis(51000)));
               
        sequentialFarmer8.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                egg.setVisible(false);
                pFarmerView.setVisible(false);
                farmerView.setVisible(true);
                translateFarmer10.play();   
                
                fullDown();
                emptyUp();
                fullOn();
            }        
        });
        sequentialFarmer8.play();
        
        // Galinha acorda
        SequentialTransition sequentialDelayChicken1 = new SequentialTransition(new PauseTransition(Duration.millis(52000)));
        
        sequentialDelayChicken1.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                         
                sChickenView.setVisible(false);
                myChickenView.setVisible(true);
                zView.setVisible(false);
            }        
        });
        sequentialDelayChicken1.play();
        
        /*------------------------------------------ Cena 8 ----------------------------------------------*/
        /* Retrata a galinha(produtor) enchendo o ninho e dormindo em seguida, e o fazendeiro(consumidor) */
        /* pegando o ovo e acordando-a                                                                    */
        
        // Galinha bota ovo
        TranslateTransition translateChicken17 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken17.setFromY(20);
        translateChicken17.setToY(-50);        
        
        TranslateTransition translateEgg17 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg17.setFromY(160);
        translateEgg17.setToY(250);        
      
        RotateTransition rotateEgg9 = new RotateTransition(Duration.millis(2000), egg);
        rotateEgg9.setByAngle(360);
                        
        TranslateTransition translateEgg18 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg18.setFromX(50);
        translateEgg18.setToX(192);     

        ParallelTransition parallelEgg9 = new ParallelTransition();
        parallelEgg9.getChildren().addAll(translateEgg15, rotateEgg8, translateEgg16);
        
        SequentialTransition sequentialChicken18 = new SequentialTransition(new PauseTransition(Duration.millis(52800)), translateChicken17);
        sequentialChicken18.play();
        
        sequentialChicken18.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(false);
                pChickenView.setVisible(true);
                egg.setVisible(true); 
                egg2.setVisible(true);
                parallelEgg9.play();           
            }        
        });
        sequentialChicken18.play();
        
        TranslateTransition translateChicken18 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken18.setFromY(-50);
        translateChicken18.setToY(20);
        
        SequentialTransition sequentialChicken19 = new SequentialTransition(new PauseTransition(Duration.millis(54300)));
        
        sequentialChicken19.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){               
                myChickenView.setVisible(true);
                pChickenView.setVisible(false);       
                translateChicken18.play();
                fullUp();
                emptyDown();
                fullOn();
            }        
        });
        sequentialChicken19.play();
                
        // Fazendeiro pega ovo
        TranslateTransition translateFarmer11 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer11.setFromX(0);
        translateFarmer11.setToX(-60);  
        
        SequentialTransition sequentialDelayFarmer8 = new SequentialTransition(new PauseTransition(Duration.millis(57000)), translateFarmer11);
        
        sequentialDelayFarmer8.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){
                farmerView.setVisible(false);
                pFarmerView.setVisible(true);               
            }        
        });
        sequentialDelayFarmer8.play(); 
        
        TranslateTransition translateFarmer12 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer12.setFromX(-60);
        translateFarmer12.setToX(0);
        
        SequentialTransition sequentialFarmer9 = new SequentialTransition(new PauseTransition(Duration.millis(58500)));
               
        sequentialFarmer9.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                egg.setVisible(false);
                pFarmerView.setVisible(false);
                farmerView.setVisible(true);
                translateFarmer12.play(); 
                
                fullDown();
                emptyUp(); 
                fullOn();
                                            
            }        
        });
        sequentialFarmer9.play();
        
        /*------------------------------------------ Cena 9 ----------------------------------------------*/
        /* Retrata o fazendeiro(consumidor) apeanas consumindo                                            */
        
        // Fazendeiro pega ovo
        TranslateTransition translateFarmer13 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer13.setFromX(0);
        translateFarmer13.setToX(-60);  
        
        SequentialTransition sequentialDelayFarmer9 = new SequentialTransition(new PauseTransition(Duration.millis(60800)), translateFarmer13);
        
        sequentialDelayFarmer9.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){
                farmerView.setVisible(false);
                pFarmerView.setVisible(true);               
            }        
        });
        sequentialDelayFarmer9.play(); 
        
        TranslateTransition translateFarmer14 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer14.setFromX(-60);
        translateFarmer14.setToX(0);
        
        SequentialTransition sequentialFarmer10 = new SequentialTransition(new PauseTransition(Duration.millis(62300)));
               
        sequentialFarmer10.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                egg0.setVisible(false);
                pFarmerView.setVisible(false);
                farmerView.setVisible(true);
                translateFarmer14.play();
             
                fullDown();
                emptyUp();  
                fullOn();
            }        
        });
        sequentialFarmer10.play();
        
        // Fazendeiro pega ovo
        TranslateTransition translateFarmer15 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer15.setFromX(0);
        translateFarmer15.setToX(-60);  
        
        SequentialTransition sequentialDelayFarmer10 = new SequentialTransition(new PauseTransition(Duration.millis(63500)), translateFarmer15);
        
        sequentialDelayFarmer10.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){
                farmerView.setVisible(false);
                pFarmerView.setVisible(true);               
            }        
        });
        sequentialDelayFarmer10.play(); 
        
        TranslateTransition translateFarmer16 = new TranslateTransition(Duration.millis(900), farmerView);
        translateFarmer16.setFromX(-60);
        translateFarmer16.setToX(0);
        
        SequentialTransition sequentialFarmer11 = new SequentialTransition(new PauseTransition(Duration.millis(65000)));
               
        sequentialFarmer11.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                egg1.setVisible(false);
                pFarmerView.setVisible(false);
                farmerView.setVisible(true);
                translateFarmer16.play(); 
              
                fullDown();
                emptyUp();
                fullOn();
            }        
        });
        sequentialFarmer11.play();
        
        /*------------------------------------------ Cena 10 ----------------------------------------------*/
        /* Retrata a galinha(produtor) produzindo                                                          */
        
        // Galinha bota ovo
        TranslateTransition translateChicken19 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken19.setFromY(20);
        translateChicken19.setToY(-50);        
        
        TranslateTransition translateEgg19 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg19.setFromY(160);
        translateEgg19.setToY(250);        
      
        RotateTransition rotateEgg10 = new RotateTransition(Duration.millis(2000), egg);
        rotateEgg10.setByAngle(360);
                        
        TranslateTransition translateEgg20 = new TranslateTransition(Duration.millis(2000), egg);
        translateEgg20.setFromX(50);
        translateEgg20.setToX(160);     

        ParallelTransition parallelEgg10 = new ParallelTransition();
        parallelEgg10.getChildren().addAll(translateEgg19, rotateEgg10, translateEgg20);
        
        SequentialTransition sequentialChicken21 = new SequentialTransition(new PauseTransition(Duration.millis(65900)), translateChicken19);
        sequentialChicken21.play();
        
        sequentialChicken21.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){                
                myChickenView.setVisible(false);
                pChickenView.setVisible(true);
                egg.setVisible(true);                
                parallelEgg10.play();           
            }        
        });
        sequentialChicken21.play();
        
        TranslateTransition translateChicken20 = new TranslateTransition(Duration.millis(800), myChickenView);
        translateChicken20.setFromY(-50);
        translateChicken20.setToY(20);
        
        SequentialTransition sequentialChicken22 = new SequentialTransition(new PauseTransition(Duration.millis(67400)));
        
        sequentialChicken22.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
            @Override public void handle(ActionEvent actionEvent){               
                myChickenView.setVisible(true);
                pChickenView.setVisible(false);                
                translateChicken20.play();   
                
                fullUp();
                emptyDown(); 
                fullOn();
                reset.setDisable(false);
            }        
        });
        sequentialChicken22.play();
        
    }
    
    public void playThis(){

        if (step == 1){ // down full
            
            if (language == 1)nextstep.setText("Next Step");
            else nextstep.setText("Próximo passo");
            nextstep.setDisable(true);reset.setDisable(true);

            table2_1.setVisible(true);

            // Fazendeiro tenta pegar ovo
            TranslateTransition translateFarmer1 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer1.setFromX(0);
            translateFarmer1.setToX(-60);

            SequentialTransition sequentialFarmer1 = new SequentialTransition();
            sequentialFarmer1.getChildren().addAll(translateFarmer1);
            sequentialFarmer1.play();       

            SequentialTransition sequentialDelayFarmer1 = new SequentialTransition(new PauseTransition(Duration.millis(3000)));

            sequentialDelayFarmer1.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){
                    farmerView.setVisible(false);
                    pFarmerView.setVisible(true);               
                }        
            });
            sequentialDelayFarmer1.play();        

            // Fazendeiro dorme
            TranslateTransition translateZ = new TranslateTransition(Duration.millis(1000), zFarmerView);
            translateZ.setToY(-10);
            translateZ.setToX(30);
            translateZ.setCycleCount(Timeline.INDEFINITE);

            SequentialTransition sequentialFarmer2 = new SequentialTransition(new PauseTransition(Duration.millis(5500)));

            sequentialFarmer2.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){                
                    pFarmerView.setVisible(false);
                    sFarmerView.setVisible(true);
                    zFarmerView.setVisible(true);
                    translateZ.play();
                    nextstep.setDisable(false);reset.setDisable(false);
                }        
            });
            sequentialFarmer2.play();   
        }

        if (step == 2) { // create

            table1_1.setVisible(true);

        }

        if (step == 3){ // down empty

            emptyDown();

            table1_1.setVisible(false);
            table1_2.setVisible(true);
        }

        if (step == 4){ // down mutex

            mutexDown();

            nextstep.setDisable(true);reset.setDisable(true);

            table1_2.setVisible(false);
            table1_3.setVisible(true);

            // Galinha bota ovo        
            TranslateTransition translateChicken1 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken1.setFromY(20);
            translateChicken1.setToY(-50); 

            translateChicken1.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });

            translateChicken1.play();

        }

        if (step == 5){ // insert

            mutexOff();

            table1_3.setVisible(false);
            table1_4.setVisible(true);

            nextstep.setDisable(true);reset.setDisable(true);

            TranslateTransition translateEgg1 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg1.setFromY(160);
            translateEgg1.setToY(250);        

            RotateTransition rotateEgg1 = new RotateTransition(Duration.millis(2000), egg);
            rotateEgg1.setByAngle(360);

            TranslateTransition translateEgg2 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg2.setFromX(50);
            translateEgg2.setToX(176);     

            ParallelTransition parallelEgg1 = new ParallelTransition();
            parallelEgg1.getChildren().addAll(translateEgg1, rotateEgg1, translateEgg2);

            myChickenView.setVisible(false);
            pChickenView.setVisible(true);
            egg.setVisible(true);
            parallelEgg1.play(); 

            parallelEgg1.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });

        }

        if (step == 6){ // up mutex

            mutexUp();

            nextstep.setDisable(true);reset.setDisable(true);

            table1_4.setVisible(false);
            table1_5.setVisible(true);

            TranslateTransition translateChicken2 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken2.setFromY(-50);
            translateChicken2.setToY(20);

            myChickenView.setVisible(true);
            pChickenView.setVisible(false);       
            translateChicken2.play();

            translateChicken2.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });

        }

        if (step == 7){ // up full

            mutexOff();

            table1_5.setVisible(false);
            table1_6.setVisible(true);

            // Fazendeiro é acordado

            zFarmerView.setVisible(false);
            sFarmerView.setVisible(false);
            pFarmerView.setVisible(true);                    

        }

        if (step == 8){ // down mutex

            mutexDown();

            table1_6.setVisible(false);

            table2_1.setVisible(false);
            table2_2.setVisible(true);

        }

        if (step == 9){ //remove

            mutexOff();

            table2_2.setVisible(false);
            table2_3.setVisible(true);

            egg.setVisible(false);

        }

        if (step == 10){ // up mutex

            mutexUp();

            table2_3.setVisible(false);
            table2_4.setVisible(true);

        }

        if (step == 11){ // up empty

            emptyUp();

            table2_4.setVisible(false);
            table2_5.setVisible(true);

            nextstep.setDisable(true);reset.setDisable(true);

            TranslateTransition translateFarmer2 = new TranslateTransition(Duration.millis(800), farmerView);
            translateFarmer2.setFromX(-60);
            translateFarmer2.setToX(0);

            pFarmerView.setVisible(false);
            farmerView.setVisible(true);
            translateFarmer2.play();

            translateFarmer2.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 12){ // process

            emptyOff();

            table2_5.setVisible(false);
            table2_6.setVisible(true);

        }


        if (step == 13){ // create

            table2_6.setVisible(false);

            table1_1.setVisible(true);                    

        }

        if (step == 14){ // down empty

            emptyDown();                     

            table1_1.setVisible(false);
            table1_2.setVisible(true);
        }

        if (step == 15){ // down mutex

            mutexDown();

            table1_2.setVisible(false);
            table1_3.setVisible(true);

            nextstep.setDisable(true);reset.setDisable(true);

            // Galinha sobe
            TranslateTransition translateChicken3 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken3.setFromY(20);
            translateChicken3.setToY(-50);  

            translateChicken3.play();

            translateChicken3.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });

        }
        if (step == 16){ // insert

            mutexOff();

            table1_3.setVisible(false);
            table1_4.setVisible(true);

            nextstep.setDisable(true);reset.setDisable(true);

            TranslateTransition translateEgg3 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg3.setFromY(160);
            translateEgg3.setToY(250);        

            RotateTransition rotateEgg2 = new RotateTransition(Duration.millis(2000), egg);
            rotateEgg2.setByAngle(360);

            TranslateTransition translateEgg4 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg4.setFromX(50);
            translateEgg4.setToX(176);     

            ParallelTransition parallelEgg2 = new ParallelTransition();
            parallelEgg2.getChildren().addAll(translateEgg3, rotateEgg2, translateEgg4);

            myChickenView.setVisible(false);
            pChickenView.setVisible(true);
            egg.setVisible(true);                
            parallelEgg2.play();      

            parallelEgg2.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 17){ //up mutex

            table1_4.setVisible(false);
            table1_5.setVisible(true);

            mutexUp();  

            nextstep.setDisable(true);reset.setDisable(true);

            TranslateTransition translateChicken4 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken4.setFromY(-50);
            translateChicken4.setToY(20);

            myChickenView.setVisible(true);
            pChickenView.setVisible(false);
            translateChicken4.play();

            translateChicken4.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 18){ // up full

            fullUp();

            table1_5.setVisible(false);
            table1_6.setVisible(true);


        }

        if (step == 19) { // create

            fullOff();

            table1_6.setVisible(false);
            table1_1.setVisible(true);

        }

        if (step == 20){ // down empty

            emptyDown();  

            table1_1.setVisible(false);
            table1_2.setVisible(true);
        }

        if (step == 21){ // down mutex

            mutexDown();

            nextstep.setDisable(true);reset.setDisable(true);

            table1_2.setVisible(false);
            table1_3.setVisible(true);

            // Galinha sobe
            TranslateTransition translateChicken5 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken5.setFromY(20);
            translateChicken5.setToY(-50); 

            translateChicken5.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });

            translateChicken5.play();
        }

        if (step == 22){ // insert

            mutexOff();

            table1_3.setVisible(false);
            table1_4.setVisible(true);

            nextstep.setDisable(true);reset.setDisable(true);

            TranslateTransition translateEgg5 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg5.setFromY(160);
            translateEgg5.setToY(250);        

            RotateTransition rotateEgg3 = new RotateTransition(Duration.millis(2000), egg);
            rotateEgg3.setByAngle(360);

            TranslateTransition translateEgg6 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg6.setFromX(50);
            translateEgg6.setToX(160);     

            ParallelTransition parallelEgg3 = new ParallelTransition();
            parallelEgg3.getChildren().addAll(translateEgg5, rotateEgg3, translateEgg6);

            myChickenView.setVisible(false);
            pChickenView.setVisible(true);
            egg.setVisible(true); 
            egg0.setVisible(true);
            parallelEgg3.play();   

            parallelEgg3.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });

        }

        if (step == 23){ // up mutex

            mutexUp();

            nextstep.setDisable(true);reset.setDisable(true);

            table1_4.setVisible(false);
            table1_5.setVisible(true);

            TranslateTransition translateChicken7 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken7.setFromY(-50);
            translateChicken7.setToY(20);

            myChickenView.setVisible(true);
            pChickenView.setVisible(false);       
            translateChicken7.play();

            translateChicken7.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });

        }    

        if (step == 24){ // up full

            fullUp();

            table1_5.setVisible(false);
            table1_6.setVisible(true);


        }

        if (step == 25){ // down full

            nextstep.setDisable(true);reset.setDisable(true);

            fullDown();

            table1_6.setVisible(false);
            table2_1.setVisible(true);

            // Fazendeiro tenta pegar ovo
            TranslateTransition translateFarmer3 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer3.setFromX(0);
            translateFarmer3.setToX(-60);  

            translateFarmer3.play();

            farmerView.setVisible(false);
            pFarmerView.setVisible(true);     

            translateFarmer3.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });

        }

        if (step == 26){ // down mutex

            mutexDown();

            table2_1.setVisible(false);
            table2_2.setVisible(true);

        }

        if (step == 27){ // remove  

            mutexOff();

            table2_2.setVisible(false);
            table2_3.setVisible(true);

            egg.setVisible(false);
        }

        if (step == 28){ // up mutex

            mutexUp();

            table2_3.setVisible(false);
            table2_4.setVisible(true); 

        }

        if (step == 29){// up empty

            emptyUp();

            table2_4.setVisible(false);
            table2_5.setVisible(true); 

            TranslateTransition translateFarmer4 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer4.setFromX(-60);
            translateFarmer4.setToX(0);

            pFarmerView.setVisible(false);
            farmerView.setVisible(true);
            translateFarmer4.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer4.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 30){ // process

            emptyOff();

            table2_5.setVisible(false);
            table2_6.setVisible(true); 

        }

        if (step == 31){ // down full  

            fullDown();

            table2_6.setVisible(false);
            table2_1.setVisible(true);

            TranslateTransition translateFarmer5 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer5.setFromX(0);
            translateFarmer5.setToX(-60);  

            translateFarmer5.play();

            farmerView.setVisible(false);
            pFarmerView.setVisible(true);  

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer5.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 32){// down mutex

            mutexDown();

            table2_1.setVisible(false);
            table2_2.setVisible(true);
        }

        if (step == 33){ // remove 

            mutexOff();

            egg0.setVisible(false);

            table2_2.setVisible(false);
            table2_3.setVisible(true);

        }

        if (step == 34){ // up mutex

            mutexUp();

            table2_3.setVisible(false);
            table2_4.setVisible(true);  
        }

        if (step == 35){// up empty

            emptyUp();

            table2_4.setVisible(false);
            table2_5.setVisible(true);

            TranslateTransition translateFarmer6 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer6.setFromX(-60);
            translateFarmer6.setToX(0);

            pFarmerView.setVisible(false);
            farmerView.setVisible(true);
            translateFarmer6.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer6.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if(step == 36){// process

            emptyOff();

            table2_5.setVisible(false);
            table2_6.setVisible(true);
        }

        if (step == 37){// down full 
        
            nextstep.setDisable(true);reset.setDisable(true);
            
            table2_6.setVisible(false);
            table2_1.setVisible(true);

            TranslateTransition translateFarmer7 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer7.setFromX(0);
            translateFarmer7.setToX(-60);  

            translateFarmer7.play();

            farmerView.setVisible(false);
            pFarmerView.setVisible(true);               

            TranslateTransition translateZ2 = new TranslateTransition(Duration.millis(1000), zFarmerView);
            translateZ2.setToY(-10);
            translateZ2.setToX(30);
            translateZ2.setCycleCount(Timeline.INDEFINITE);

            SequentialTransition sequentialFarmer4 = new SequentialTransition(new PauseTransition(Duration.millis(1000)));

            sequentialFarmer4.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){                
                    pFarmerView.setVisible(false);
                    sFarmerView.setVisible(true);
                    zFarmerView.setVisible(true);
                    translateZ2.play();
                    nextstep.setDisable(false);reset.setDisable(false);
                }        
            });
            sequentialFarmer4.play();
        }

        if (step == 38){// create

            table1_1.setVisible(true);
        }

        if (step == 39){// down empty
            
            emptyDown();

            table1_1.setVisible(false);
            table1_2.setVisible(true);
        }

        if (step == 40){// down mutex

            mutexDown();

            table1_2.setVisible(false);
            table1_3.setVisible(true);

            TranslateTransition translateChicken6 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken6.setFromY(20);
            translateChicken6.setToY(-50);   

            translateChicken6.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken6.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if(step == 41){// insert

            mutexOff();

            table1_3.setVisible(false);
            table1_4.setVisible(true);

            TranslateTransition translateEgg7 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg7.setFromY(160);
            translateEgg7.setToY(250);        

            RotateTransition rotateEgg4 = new RotateTransition(Duration.millis(2000), egg);
            rotateEgg4.setByAngle(360);

            TranslateTransition translateEgg8 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg8.setFromX(50);
            translateEgg8.setToX(176);     

            ParallelTransition parallelEgg4 = new ParallelTransition();
            parallelEgg4.getChildren().addAll(translateEgg7, rotateEgg4, translateEgg8);

            myChickenView.setVisible(false);
            pChickenView.setVisible(true);
            egg.setVisible(true);                
            parallelEgg4.play();

            nextstep.setDisable(true);reset.setDisable(true);
            parallelEgg4.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if(step == 42){// up mutex

            mutexUp();

            table1_4.setVisible(false);
            table1_5.setVisible(true);

            TranslateTransition translateChicken8 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken8.setFromY(-50);
            translateChicken8.setToY(20);

            myChickenView.setVisible(true);
            pChickenView.setVisible(false);       
            translateChicken8.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken8.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 43){//up full

            table1_5.setVisible(false);
            table1_6.setVisible(true);
            
            zFarmerView.setVisible(false);
            sFarmerView.setVisible(false);
            pFarmerView.setVisible(true); 
        }

        if (step == 44){// down mutex (fazendeiro)

            mutexDown();

            table1_6.setVisible(false);
            table2_1.setVisible(false);
            table2_2.setVisible(true);

        }

        if (step == 45){// remove

            mutexOff();

            table2_2.setVisible(false);
            table2_3.setVisible(true); 

            egg.setVisible(false);
        }

        if (step == 46){// up mutex

            mutexUp();

            table2_3.setVisible(false);
            table2_4.setVisible(true); 
        }

        if (step == 47){// up empty

            emptyUp();

            table2_4.setVisible(false);
            table2_5.setVisible(true); 

            TranslateTransition translateFarmer8 = new TranslateTransition(Duration.millis(800), farmerView);
            translateFarmer8.setFromX(-60);
            translateFarmer8.setToX(0);

            pFarmerView.setVisible(false);
            farmerView.setVisible(true);
            translateFarmer8.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer8.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 48){// process

            emptyOff();

            table2_5.setVisible(false);
            table2_6.setVisible(true); 
        }

        if (step == 49){// create

            table2_6.setVisible(false);
            table1_1.setVisible(true); 
        }

        if (step == 50){// down empty

            emptyDown();

            table1_1.setVisible(false);
            table1_2.setVisible(true); 

        }

        if (step == 51){// down mutex 

            mutexDown();

            table1_2.setVisible(false);
            table1_3.setVisible(true); 

            TranslateTransition translateChicken9 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken9.setFromY(20);
            translateChicken9.setToY(-50);        

            translateChicken9.play();

            nextstep.setDisable(true);reset.setDisable(true);                    
            translateChicken9.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 52){// insert 

            emptyOff();

            table1_3.setVisible(false);
            table1_4.setVisible(true); 

            TranslateTransition translateEgg9 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg9.setFromY(160);
            translateEgg9.setToY(250);        

            RotateTransition rotateEgg5 = new RotateTransition(Duration.millis(2000), egg);
            rotateEgg5.setByAngle(360);

            TranslateTransition translateEgg10 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg10.setFromX(50);
            translateEgg10.setToX(176);     

            ParallelTransition parallelEgg5 = new ParallelTransition();
            parallelEgg5.getChildren().addAll(translateEgg9, rotateEgg5, translateEgg10);

            myChickenView.setVisible(false);
            pChickenView.setVisible(true);
            egg.setVisible(true);                
            parallelEgg5.play();   

            nextstep.setDisable(true);reset.setDisable(true);
            parallelEgg5.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if(step == 53){// up mutex

            mutexUp();

            table1_4.setVisible(false);
            table1_5.setVisible(true);                     

            TranslateTransition translateChicken10 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken10.setFromY(-50);
            translateChicken10.setToY(20);

            myChickenView.setVisible(true);
            pChickenView.setVisible(false);
            translateChicken10.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken10.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if(step == 54){//up full

            fullUp();

            table1_5.setVisible(false);
            table1_6.setVisible(true);  
        }

        if (step == 55){// create 

            fullOff();

            table1_6.setVisible(false);
            table1_1.setVisible(true);  

        }

        if (step == 56){// down empty

            emptyDown();

            table1_1.setVisible(false);
            table1_2.setVisible(true);  
        }

        if(step == 57){// down mutex

            mutexDown();

            table1_2.setVisible(false);
            table1_3.setVisible(true);  

            TranslateTransition translateChicken11 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken11.setFromY(20);
            translateChicken11.setToY(-50);        

            translateChicken11.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken11.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 58){// insert

            mutexOff();

            table1_3.setVisible(false);
            table1_4.setVisible(true);  

            TranslateTransition translateEgg11 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg11.setFromY(160);
            translateEgg11.setToY(250);        

            RotateTransition rotateEgg6 = new RotateTransition(Duration.millis(2000), egg);
            rotateEgg6.setByAngle(360);

            TranslateTransition translateEgg12 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg12.setFromX(50);
            translateEgg12.setToX(160);     

            ParallelTransition parallelEgg6 = new ParallelTransition();
            parallelEgg6.getChildren().addAll(translateEgg11, rotateEgg6, translateEgg12);

            myChickenView.setVisible(false);
            pChickenView.setVisible(true);
            egg.setVisible(true); 
            egg0.setVisible(true);
            parallelEgg6.play();  

            nextstep.setDisable(true);reset.setDisable(true);
            parallelEgg6.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 59){// up mutex

            mutexUp();

            table1_4.setVisible(false);
            table1_5.setVisible(true);  

            TranslateTransition translateChicken12 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken12.setFromY(-50);
            translateChicken12.setToY(20);

            myChickenView.setVisible(true);
            pChickenView.setVisible(false);       
            translateChicken12.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken12.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 60){// up full

            fullUp();

            table1_5.setVisible(false);
            table1_6.setVisible(true);  
        }

        if (step == 61){// create

            fullOff();

            table1_6.setVisible(false);
            table1_1.setVisible(true);                    

        }

        if (step == 62){// down empty

            emptyDown();

            table1_1.setVisible(false);
            table1_2.setVisible(true);  
        }

        if (step == 63){// down mutex

            mutexDown();

            table1_2.setVisible(false);
            table1_3.setVisible(true);  

            TranslateTransition translateChicken13 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken13.setFromY(20);
            translateChicken13.setToY(-50);  

            translateChicken13.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken13.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 64){// insert

            mutexOff();

            table1_3.setVisible(false);
            table1_4.setVisible(true);  

            TranslateTransition translateEgg13 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg13.setFromY(160);
            translateEgg13.setToY(250);        

            RotateTransition rotateEgg7 = new RotateTransition(Duration.millis(2000), egg);
            rotateEgg7.setByAngle(360);

            TranslateTransition translateEgg14 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg14.setFromX(50);
            translateEgg14.setToX(142);     

            ParallelTransition parallelEgg7 = new ParallelTransition();
            parallelEgg7.getChildren().addAll(translateEgg13, rotateEgg7, translateEgg14);

            myChickenView.setVisible(false);
            pChickenView.setVisible(true);
            egg.setVisible(true);  
            egg1.setVisible(true);
            parallelEgg7.play(); 

            nextstep.setDisable(true);reset.setDisable(true);
            parallelEgg7.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });

        }

        if (step == 65){// up mutex

            mutexUp();

            table1_4.setVisible(false);
            table1_5.setVisible(true);                    

            TranslateTransition translateChicken14 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken14.setFromY(-50);
            translateChicken14.setToY(20);

            myChickenView.setVisible(true);
            pChickenView.setVisible(false);
            translateChicken14.play();    

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken14.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });

        }

        if(step == 66){// up full

            fullUp();

            table1_5.setVisible(false);
            table1_6.setVisible(true);  
        }

        if (step == 67){// create

            fullOff();

            table1_6.setVisible(false);
            table1_1.setVisible(true);  
        }

        if (step == 68){// down empty

            emptyDown();

            table1_1.setVisible(false);
            table1_2.setVisible(true);  

        }

        if (step == 69){// down mutex

            mutexDown();

            table1_2.setVisible(false);
            table1_3.setVisible(true);                      

            TranslateTransition translateChicken15 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken15.setFromY(20);
            translateChicken15.setToY(-50); 

            translateChicken15.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken15.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });   

        }

        if (step == 70){// insert   

            mutexOff();

            table1_3.setVisible(false);
            table1_4.setVisible(true); 

            TranslateTransition translateEgg15 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg15.setFromY(160);
            translateEgg15.setToY(250);        

            RotateTransition rotateEgg8 = new RotateTransition(Duration.millis(2000), egg);
            rotateEgg8.setByAngle(360);

            TranslateTransition translateEgg16 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg16.setFromX(50);
            translateEgg16.setToX(192);     

            ParallelTransition parallelEgg8 = new ParallelTransition();
            parallelEgg8.getChildren().addAll(translateEgg15, rotateEgg8, translateEgg16);

            myChickenView.setVisible(false);
            pChickenView.setVisible(true);
            egg.setVisible(true); 
            egg2.setVisible(true);
            parallelEgg8.play();   

            nextstep.setDisable(true);reset.setDisable(true);
            parallelEgg8.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });   
        }

        if (step == 71){// up mutex

            mutexUp();

            table1_4.setVisible(false);
            table1_5.setVisible(true); 

            TranslateTransition translateChicken16 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken16.setFromY(-50);
            translateChicken16.setToY(20);

            myChickenView.setVisible(true);
            pChickenView.setVisible(false);       
            translateChicken16.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken16.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });   
        }

        if (step == 72){// up full

            fullUp();

            table1_5.setVisible(false);
            table1_6.setVisible(true); 
        }

        if (step == 73){// create

            fullOff();

            table1_6.setVisible(false);
            table1_1.setVisible(true);   

        }

        if (step == 74){// down empty

            table1_1.setVisible(false);
            table1_2.setVisible(true);   

            TranslateTransition translateChickenZ = new TranslateTransition(Duration.millis(1000), zView);
            translateChickenZ.setToY(-10);
            translateChickenZ.setToX(30);
            translateChickenZ.setCycleCount(Timeline.INDEFINITE);

            zView.setVisible(true);
            myChickenView.setVisible(false);
            sChickenView.setVisible(true);
            translateChickenZ.play();

            final SequentialTransition delay1 = new SequentialTransition (new PauseTransition(Duration.millis(2000)));
            delay1.play();
            
            nextstep.setDisable(true);reset.setDisable(true);
            delay1.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });                      
        }

        if (step == 75){// down full

            fullDown();

            table2_1.setVisible(true); 

            TranslateTransition translateFarmer9 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer9.setFromX(0);
            translateFarmer9.setToX(-60);  

            translateFarmer9.play();

            farmerView.setVisible(false);
            pFarmerView.setVisible(true);   

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer9.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            }); 

        }

        if (step == 76){//down mutex

            mutexDown();

            table2_1.setVisible(false);
            table2_2.setVisible(true);     
        }

        if (step == 77){// remove

            mutexOff();

            table2_2.setVisible(false);
            table2_3.setVisible(true); 

            egg.setVisible(false);
        }

        if (step == 78){// up mutex

            mutexUp();

            table2_3.setVisible(false);
            table2_4.setVisible(true); 
        }

        if (step == 80){ // up empty

            table2_4.setVisible(false);
            table2_5.setVisible(true);                     

            TranslateTransition translateFarmer10 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer10.setFromX(-60);
            translateFarmer10.setToX(0);

            pFarmerView.setVisible(false);
            farmerView.setVisible(true);
            translateFarmer10.play();  

            sChickenView.setVisible(false);
            myChickenView.setVisible(true);
            zView.setVisible(false);

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer10.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            }); 
        }

        if (step == 81){// process && down mutex galinha

            mutexDown();

            table2_5.setVisible(false);
            table2_6.setVisible(true);

            table1_2.setVisible(false);
            table1_3.setVisible(true);                      

            TranslateTransition translateChicken17 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken17.setFromY(20);
            translateChicken17.setToY(-50);    

            translateChicken17.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken17.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            }); 
        }

        if (step == 82){// insert

            mutexOff();

            table1_3.setVisible(false);
            table1_4.setVisible(true); 
            table2_6.setVisible(false);

            TranslateTransition translateEgg17 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg17.setFromY(160);
            translateEgg17.setToY(250);        

            RotateTransition rotateEgg9 = new RotateTransition(Duration.millis(2000), egg);
            rotateEgg9.setByAngle(360);

            TranslateTransition translateEgg18 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg18.setFromX(50);
            translateEgg18.setToX(192);     

            ParallelTransition parallelEgg9 = new ParallelTransition();
            parallelEgg9.getChildren().addAll(translateEgg18, rotateEgg9, translateEgg17);

            myChickenView.setVisible(false);
            pChickenView.setVisible(true);
            egg.setVisible(true); 
            egg2.setVisible(true);
            parallelEgg9.play();    

            nextstep.setDisable(true);reset.setDisable(true);
            parallelEgg9.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            }); 
        }

        if (step == 83){// up mutex

            mutexUp();

            table1_4.setVisible(false);
            table1_5.setVisible(true); 

            TranslateTransition translateChicken18 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken18.setFromY(-50);
            translateChicken18.setToY(20);

            myChickenView.setVisible(true);
            pChickenView.setVisible(false);       
            translateChicken18.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken18.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            }); 
        }

        if (step == 84){// up full

            fullUp();

            table1_5.setVisible(false);
            table1_6.setVisible(true);
            
            step++;

        }


        if (step == 86){// down full

            fullDown();

            table1_6.setVisible(false);
            table2_1.setVisible(true);

            TranslateTransition translateFarmer11 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer11.setFromX(0);
            translateFarmer11.setToX(-60);  

            translateFarmer11.play();

            farmerView.setVisible(false);
            pFarmerView.setVisible(true);   

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer11.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            }); 
        }

        if (step == 87){// down mutex

            mutexDown();

            table2_1.setVisible(false);
            table2_2.setVisible(true);

        }

        if (step == 88){// remove

            mutexOff();

            egg.setVisible(false);

            table2_2.setVisible(false);
            table2_3.setVisible(true);
        }

        if (step == 89){// up mutex

            mutexUp();

            table2_3.setVisible(false);
            table2_4.setVisible(true); 

        }

        if (step == 90){// up empty

            emptyUp();

            table2_4.setVisible(false);
            table2_5.setVisible(true); 

            TranslateTransition translateFarmer12 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer12.setFromX(-60);
            translateFarmer12.setToX(0);

            pFarmerView.setVisible(false);
            farmerView.setVisible(true);
            translateFarmer12.play();    

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer12.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            }); 
        }

        if (step == 91){// process

            emptyOff();

            table2_5.setVisible(false);
            table2_6.setVisible(true); 

        }

        if (step == 92){// down full

            fullDown();

            table2_6.setVisible(false);
            table2_1.setVisible(true); 

            TranslateTransition translateFarmer13 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer13.setFromX(0);
            translateFarmer13.setToX(-60);  

            translateFarmer13.play();

            farmerView.setVisible(false);
            pFarmerView.setVisible(true); 

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer13.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            }); 
        }

        if (step == 93){// down mutex

            mutexDown();

            table2_1.setVisible(false);
            table2_2.setVisible(true); 

        }

        if (step == 94){// remove

            mutexOff();

            table2_2.setVisible(false);
            table2_3.setVisible(true); 

            egg0.setVisible(false);

        }

        if (step == 95){// up mutex

            mutexUp();

            table2_3.setVisible(false);
            table2_4.setVisible(true);   

        }

        if (step == 96){// up empty

            emptyUp();

            table2_4.setVisible(false);
            table2_5.setVisible(true);   

            TranslateTransition translateFarmer14 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer14.setFromX(-60);
            translateFarmer14.setToX(0);

            pFarmerView.setVisible(false);
            farmerView.setVisible(true);
            translateFarmer14.play();    

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer14.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });
        }

        if (step == 97){// process

            emptyOff();

            table2_5.setVisible(false);
            table2_6.setVisible(true);  

        }

        if(step == 98){// down full

            fullDown();

            table2_6.setVisible(false);
            table2_1.setVisible(true);  

            TranslateTransition translateFarmer15 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer15.setFromX(0);
            translateFarmer15.setToX(-60);  

            translateFarmer15.play();

            farmerView.setVisible(false);
            pFarmerView.setVisible(true); 

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer15.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });

        }

        if (step == 99){// down mutex

            mutexDown();

            table2_1.setVisible(false);
            table2_2.setVisible(true); 
        }

        if (step == 100){// remove

            mutexOff();

            table2_2.setVisible(false);
            table2_3.setVisible(true); 

            egg1.setVisible(false);

        }

        if (step == 101){// up mutex

            mutexUp();

            table2_3.setVisible(false);
            table2_4.setVisible(true); 

        }

        if (step == 102){// up empty

            emptyUp();

            table2_4.setVisible(false);
            table2_5.setVisible(true);                     

            TranslateTransition translateFarmer16 = new TranslateTransition(Duration.millis(900), farmerView);
            translateFarmer16.setFromX(-60);
            translateFarmer16.setToX(0);

            pFarmerView.setVisible(false);
            farmerView.setVisible(true);
            translateFarmer16.play();   

            nextstep.setDisable(true);reset.setDisable(true);
            translateFarmer16.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });   
        }


        if (step == 103){// process

            emptyOff();

            table2_5.setVisible(false);
            table2_6.setVisible(true);  

        }

        if (step == 104){// create

            table2_6.setVisible(false);
            table1_1.setVisible(true);
        }

        if (step == 105){// down empty

            emptyDown();

            table1_1.setVisible(false);
            table1_2.setVisible(true);  

        }

        if (step == 106){// down mutex

            mutexDown();

            table1_2.setVisible(false);
            table1_3.setVisible(true);  

            TranslateTransition translateChicken19 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken19.setFromY(20);
            translateChicken19.setToY(-50);  

            translateChicken19.play();

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken19.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            });  
        }

        if (step == 107){// insert

            mutexOff();

            table1_3.setVisible(false);
            table1_4.setVisible(true);                     

            TranslateTransition translateEgg19 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg19.setFromY(160);
            translateEgg19.setToY(250);        

            RotateTransition rotateEgg10 = new RotateTransition(Duration.millis(2000), egg);
            rotateEgg10.setByAngle(360);

            TranslateTransition translateEgg20 = new TranslateTransition(Duration.millis(2000), egg);
            translateEgg20.setFromX(50);
            translateEgg20.setToX(160);     

            ParallelTransition parallelEgg10 = new ParallelTransition();
            parallelEgg10.getChildren().addAll(translateEgg19, rotateEgg10, translateEgg20);

            myChickenView.setVisible(false);
            pChickenView.setVisible(true);
            egg.setVisible(true);                
            parallelEgg10.play();

            nextstep.setDisable(true);reset.setDisable(true);
            parallelEgg10.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            }); 
        }

        if (step == 108){// up mutex

            mutexUp();

            table1_4.setVisible(false);
            table1_5.setVisible(true);                      

            TranslateTransition translateChicken20 = new TranslateTransition(Duration.millis(800), myChickenView);
            translateChicken20.setFromY(-50);
            translateChicken20.setToY(20);

            myChickenView.setVisible(true);
            pChickenView.setVisible(false);                
            translateChicken20.play();    

            nextstep.setDisable(true);reset.setDisable(true);
            translateChicken20.onFinishedProperty().set(new EventHandler<ActionEvent>(){    
                @Override public void handle(ActionEvent actionEvent){nextstep.setDisable(false);reset.setDisable(false);}        
            }); 
        }

        if(step == 109){// up full

            fullUp();

            table1_5.setVisible(false);
            table1_6.setVisible(true); 

            nextstep.setDisable(true);
            reset.setDisable(false);

        }   
 
    }
    public void mutexOn(){
        
        tMutex.setFill(Color.YELLOW); 
        tMutexN.setFill(Color.YELLOW); 
        
    }
    
    public void mutexOff(){
        
        tMutex.setFill(Color.DARKSLATEGREY); 
        tMutexN.setFill(Color.DARKSLATEGREY); 
        
    }
    
    public void emptyOn(){
        
        tEmpty.setFill(Color.YELLOW); 
        tEmptyN.setFill(Color.YELLOW); 
        
    }
    
    public void emptyOff(){
        
        tEmpty.setFill(Color.DARKSLATEGREY); 
        tEmptyN.setFill(Color.DARKSLATEGREY); 
        
    }
    
    public void fullOn(){
        
        tFull.setFill(Color.YELLOW); 
        tFullN.setFill(Color.YELLOW); 
        
    }
    
    public void fullOff(){
        
        tFull.setFill(Color.DARKSLATEGREY); 
        tFullN.setFill(Color.DARKSLATEGREY); 
        
    }
    
    //-----------------------------
    
    public void mutexUp(){
        
        mutexOn();
        emptyOff();
        fullOff();
        
        mutex++;
        tMutexN.setText(Integer.toString(mutex));
        
    }
        
    public void mutexDown(){
        
        mutexOn();
        emptyOff();
        fullOff();
        
        mutex--;
        tMutexN.setText(Integer.toString(mutex));
        
    }
     
    public void emptyUp(){
        
        mutexOff();
        emptyOn();
        fullOff();
        
        empty++;
        tEmptyN.setText(Integer.toString(empty));
        
    }
        
    public void emptyDown(){
        
        mutexOff();
        emptyOn();
        fullOff();
        
        empty--;
        tEmptyN.setText(Integer.toString(empty));
        
    }
    
    public void fullUp(){
        
        mutexOff();
        emptyOff();
        fullOn();
        
        full++;
        tFullN.setText(Integer.toString(full));
        
    }
        
    public void fullDown(){
        
        mutexOff();
        emptyOff();
        fullOn();
        
        full--;
        tFullN.setText(Integer.toString(full));
        
    }
    
    public static void main(String[] args) {
        launch(args);
    }
  } 
