package geladeira;

import java.util.ArrayList;
import javafx.animation.FadeTransition;
import javafx.animation.PauseTransition;
import javafx.animation.SequentialTransition;
import javafx.animation.TranslateTransition;
import static javafx.application.Application.launch;
import javafx.scene.Group;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.text.Text;
import javafx.util.Duration;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.effect.DropShadow;
import javafx.scene.image.Image;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

public class Geladeira extends Application {
    
    public int semaphore;
    public boolean cat1blocked, cat2blocked;
    
    public int language;
                    
    public ArrayList<String> data = new ArrayList<>();
    
    public Geladeira(Stage stage, int lang){
        language = lang;
        start(stage);
    }
 
    @Override
    public void start(Stage stage) {
        
        // language = 1;
        // 0 = PT-BR
        // 1 = EN
        
        final int sX = -150;
        final int sY = -90;
        
        semaphore = 0;
        cat1blocked = false;
        cat2blocked = false;
        
        if(language == 1){
            data.add("1   up(semaphore){");
            data.add("2   \tsemaphore ++;");
            data.add("3   }");
            data.add("1   down(semaphore){");
            data.add("2   \tif (semaphore == 0)");
            data.add("3   \t\t BLOCK PROCESS");
            data.add("4   \telse semaphore--;");
            data.add("5   }");

            stage.setTitle("Semaphore Example");
        }
        else{
            data.add("1   up(semaforo){");
            data.add("2   \tsemaforo ++;");
            data.add("3   }");
            data.add("1   down(semaforo){");
            data.add("2   \tif (semaforo == 0)");
            data.add("3   \t\t PROCESSO BLOQUEADO");
            data.add("4   \telse semaforo--;");
            data.add("5   }");

            stage.setTitle("Exemplo de Semáforo");    
        }
        Group root = new Group();
        final Scene scene = new Scene(root);

// BACKGROUND               
        StackPane background = new StackPane();
        ImageView imageBackground = new ImageView("/img2/background2.png");        
        background.getChildren().add(imageBackground);

        background.setTranslateX(0);
        background.setTranslateY(-3000);
        
 // BUTTONS       
        
        Button up1 = new Button("Up");
        up1.setTranslateX(sX + 800);
        up1.setTranslateY(sY + 170);
        Button down1 = new Button("Down");
        down1.setTranslateX(sX + 800);
        down1.setTranslateY(sY + 200);

        Button up2 = new Button("Up");
        up2.setTranslateX(sX + 800);
        up2.setTranslateY(sY + 370);
        Button down2 = new Button("Down");
        down2.setTranslateX(sX + 800);
        down2.setTranslateY(sY + 400);

        Button reset = new Button();
        if(language == 1) reset.setText("Reset");
        else reset.setText("Resetar");       
        reset.setTranslateX(sX + 430);
        reset.setTranslateY(sY + 510);    
        
        Button nowuseeme = new Button("Info");
        nowuseeme.setTranslateX(690);
        nowuseeme.setTranslateY(460); 
              
        nowuseeme.setFocusTraversable(false);
        
        // info
                
        Text infoProcess1 = new Text ();
        if(language == 1) infoProcess1.setText("Process 1");
        else infoProcess1.setText("Processo 1");
        infoProcess1.setFont(Font.font(null, FontWeight.BOLD, 20));
        infoProcess1.setTranslateX(640);
        infoProcess1.setTranslateY(50);
        infoProcess1.setFill(Color.GREY);  
        infoProcess1.setVisible(false);
        
        Text infoProcess2 = new Text ();
        if(language == 1) infoProcess2.setText("Process 2");
        else infoProcess2.setText("Processo 2");
        infoProcess2.setFont(Font.font(null, FontWeight.BOLD, 20));
        infoProcess2.setTranslateX(640);
        infoProcess2.setTranslateY(250);
        infoProcess2.setFill(Color.GREY);  
        infoProcess2.setVisible(false);
                
        DropShadow infoS = new DropShadow();
        
        Text infoSemaphores = new Text ();
        if(language == 1) infoSemaphores.setText("Semaphore");
        else infoSemaphores.setText("Semáforo");
        infoSemaphores.setFont(Font.font(null, FontWeight.BOLD, 30));
        infoSemaphores.setTranslateX(120);
        infoSemaphores.setTranslateY(50);
        infoSemaphores.setEffect(infoS);
        infoSemaphores.setFill(Color.WHITE);  
        infoSemaphores.setVisible(false); 
        
        nowuseeme.setOnMouseEntered(evt -> {   
            
            DropShadow shadow = new DropShadow();
            shadow.setColor(Color.SIENNA);
            shadow.setRadius(20.0);           
            nowuseeme.setEffect(shadow);
            
            infoProcess1.setVisible(true);
            infoProcess2.setVisible(true);
            infoSemaphores.setVisible(true); 
            
    
        });

        nowuseeme.setOnMouseExited(evt -> {           
            
            nowuseeme.setEffect(null);
            
            infoProcess1.setVisible(false);
            infoProcess2.setVisible(false);
            infoSemaphores.setVisible(false); 
    
        });
        
        
// REFRIGERATOR
        
        //image       
        StackPane refrigerator = new StackPane();
        ImageView imageRefrigerator = new ImageView("/img2/refrigerator.png");        
        refrigerator.getChildren().add(imageRefrigerator);
        refrigerator.setTranslateX(sX + 350);
        refrigerator.setTranslateY(sY + 100);
                   
// CAT 1 GOING
        
        // image
        StackPane cat1Going = new StackPane();
        ImageView imageCat1Going = new ImageView("/img2/cat1Going.png");        
        cat1Going.getChildren().add(imageCat1Going);
        cat1Going.setTranslateY(sY + 406);
        
        // initializing
        FadeTransition initCat1Going = new FadeTransition(Duration.millis(1), cat1Going);
        initCat1Going.setFromValue(0.0);
        initCat1Going.setToValue(0.0);
        initCat1Going.setCycleCount(1);
        initCat1Going.play();
        
        // actions
        final FadeTransition ft1Cat1Going = new FadeTransition(Duration.millis(400), cat1Going);
        ft1Cat1Going.setFromValue(0.0);
        ft1Cat1Going.setToValue(1.0);
        ft1Cat1Going.setCycleCount(1);
        
        final FadeTransition ft2Cat1Going = new FadeTransition(Duration.millis(400), cat1Going);
        ft2Cat1Going.setFromValue(1.0);
        ft2Cat1Going.setToValue(0.0);
        ft2Cat1Going.setCycleCount(1);
        
        TranslateTransition tCat1Going = new TranslateTransition(Duration.millis(2000), cat1Going);
        tCat1Going.setFromX(20);
        tCat1Going.setToX(sX + 250);
        tCat1Going.setCycleCount(1);
        
        final SequentialTransition stCat1Going = new SequentialTransition (
            new PauseTransition(Duration.millis(2000)),
            ft2Cat1Going
        );
            
// CAT 1 RETURNING        
        
        // image
        StackPane cat1Returning = new StackPane();
        ImageView imageCat1Returning = new ImageView("/img2/cat1Returning.png");
        cat1Returning.getChildren().add(imageCat1Returning); 
        cat1Returning.setTranslateY(sY + 406);
        
        // initializing
        FadeTransition initCat1Returning = new FadeTransition(Duration.millis(1), cat1Returning);
        initCat1Returning.setFromValue(0.0);
        initCat1Returning.setToValue(0.0);
        initCat1Returning.setCycleCount(1);
        initCat1Returning.play();
        
        // actions
        final FadeTransition ft1Cat1Returning = new FadeTransition(Duration.millis(1), cat1Returning);
        ft1Cat1Returning.setFromValue(0.0);
        ft1Cat1Returning.setToValue(1.0);
        ft1Cat1Returning.setCycleCount(1);
        
        final FadeTransition ft2Cat1Returning = new FadeTransition(Duration.millis(400), cat1Returning);
        ft2Cat1Returning.setFromValue(1.0);
        ft2Cat1Returning.setToValue(0.0);
        ft2Cat1Returning.setCycleCount(1);
        
        TranslateTransition tCat1Returning = new TranslateTransition(Duration.millis(2000), cat1Returning);
        tCat1Returning.setFromX(sX + 280);
        tCat1Returning.setToX(50);
        tCat1Returning.setCycleCount(1);
        
        final SequentialTransition st1Cat1Returning = new SequentialTransition (
            new PauseTransition(Duration.millis(1500)),
            ft1Cat1Returning
        );        
        
        final SequentialTransition st2Cat1Returning = new SequentialTransition (
            new PauseTransition(Duration.millis(1500)),   
            tCat1Returning
        );
        
        final SequentialTransition st3Cat1Returning = new SequentialTransition (
            new PauseTransition(Duration.millis(3100)),
            ft2Cat1Returning
        );
        
// CAT 1 PROCESS
        
        // image
        StackPane cat1Process = new StackPane();
        ImageView imageCat1Process = new ImageView("/img2/cat1Going.png");        
        cat1Process.getChildren().add(imageCat1Process);
        cat1Process.setTranslateX(sX + 700);
        cat1Process.setTranslateY(sY + 210);
        
// CAT 2 GOING
        
        // image
        StackPane cat2Going = new StackPane();       
        ImageView imageCat2Going = new ImageView("/img2/cat2Going.png");        
        cat2Going.getChildren().add(imageCat2Going);
        cat2Going.setTranslateY(sY + 406);  
        
        // initializing
        FadeTransition initCat2Going = new FadeTransition(Duration.millis(1), cat2Going);
        initCat2Going.setFromValue(0.0);
        initCat2Going.setToValue(0.0);
        initCat2Going.setCycleCount(1);
        initCat2Going.play();
        
        // actions
        final FadeTransition ft1Cat2Going = new FadeTransition(Duration.millis(400), cat2Going);
        ft1Cat2Going.setFromValue(0.0);
        ft1Cat2Going.setToValue(1.0);
        ft1Cat2Going.setCycleCount(1);
        
        final FadeTransition ft2Cat2Going = new FadeTransition(Duration.millis(400), cat2Going);
        ft2Cat2Going.setFromValue(1.0);
        ft2Cat2Going.setToValue(0.0);
        ft2Cat2Going.setCycleCount(1);
        
        TranslateTransition tCat2Going = new TranslateTransition(Duration.millis(2000), cat2Going);
        tCat2Going.setFromX(20);
        tCat2Going.setToX(sX + 250);
        tCat2Going.setCycleCount(1);
        
        final SequentialTransition stCat2Going = new SequentialTransition (
            new PauseTransition(Duration.millis(2000)), 
            ft2Cat2Going
        );
                        
// CAT 2 RETURNING        
        
        // image
        StackPane cat2Returning = new StackPane();        
        ImageView imageCat2Returning = new ImageView("/img2/cat2Returning.png");        
        cat2Returning.getChildren().add(imageCat2Returning);
        cat2Returning.setTranslateY(sY + 406);       

        // initializing
        FadeTransition initCat2Returning = new FadeTransition(Duration.millis(1), cat2Returning);
        initCat2Returning.setFromValue(0.0);
        initCat2Returning.setToValue(0.0);
        initCat2Returning.setCycleCount(1);
        initCat2Returning.play();
        
        // actions
        final FadeTransition ft1Cat2Returning = new FadeTransition(Duration.millis(1), cat2Returning);
        ft1Cat2Returning.setFromValue(0.0);
        ft1Cat2Returning.setToValue(1.0);
        ft1Cat2Returning.setCycleCount(1);
        
        final FadeTransition ft2Cat2Returning = new FadeTransition(Duration.millis(400), cat2Returning);
        ft2Cat2Returning.setFromValue(1.0);
        ft2Cat2Returning.setToValue(0.0);
        ft2Cat2Returning.setCycleCount(1);
        
        TranslateTransition tCat2Returning = new TranslateTransition(Duration.millis(2000), cat2Returning);
        tCat2Returning.setFromX(sX + 280);
        tCat2Returning.setToX(50);
        tCat2Returning.setCycleCount(1);
        
        final SequentialTransition st1Cat2Returning = new SequentialTransition (
            new PauseTransition(Duration.millis(1500)),
            ft1Cat2Returning
        );        
        
        final SequentialTransition st2Cat2Returning = new SequentialTransition (
            new PauseTransition(Duration.millis(1500)),
            tCat2Returning
        );
        
        final SequentialTransition st3Cat2Returning = new SequentialTransition (
            new PauseTransition(Duration.millis(3100)),
            ft2Cat2Returning
        );       
        
// CAT 2 PROCESS
        
        // image
        StackPane cat2Process = new StackPane();
        ImageView imageCat2Process = new ImageView("/img2/cat2Going.png");        
        cat2Process.getChildren().add(imageCat2Process);
        cat2Process.setTranslateX(sX + 700);
        cat2Process.setTranslateY(sY + 410);
        
// BALLOON 1
        
        // image
        StackPane balloon1 = new StackPane();
        ImageView imageBalloon1 = new ImageView("/img2/balloon.png");        
        balloon1.getChildren().add(imageBalloon1);
        balloon1.setTranslateX(sX + 690);
        balloon1.setTranslateY(sY + 100);
        
// BALLOON 2
        
        // image
        StackPane balloon2 = new StackPane();
        ImageView imageBalloon2 = new ImageView("/img2/balloon.png");
        balloon2.getChildren().add(imageBalloon2);
        balloon2.setTranslateX(sX + 690);
        balloon2.setTranslateY(sY + 300);        

// LOCKED 1
        
        // image
        StackPane locked1 = new StackPane();
        ImageView imageLocked1 = new ImageView("/img2/locked1.png");
        locked1.getChildren().add(imageLocked1);
        locked1.setTranslateY(sY + 100);
        
        // initializing 
        FadeTransition initLocked1 = new FadeTransition(Duration.millis(1), locked1);
        initLocked1.setToValue(0.0);
        initLocked1.setCycleCount(1);
        initLocked1.play();
        
        // actions
// LOCKED 1 SLEEP
        
        final FadeTransition ftLocked1Sleep = new FadeTransition(Duration.millis(1000), locked1);
        ftLocked1Sleep.setToValue(1.0);
        ftLocked1Sleep.setCycleCount(1);
        
        TranslateTransition tLocked1Sleep = new TranslateTransition(Duration.millis(1), locked1);
        tLocked1Sleep.setFromX(sX + 1000);
        tLocked1Sleep.setToX(sX + 680);
        tLocked1Sleep.setCycleCount(1);
                  
// LOCKED 1 WAKEUP
        
        FadeTransition stayLocked1 = new FadeTransition(Duration.millis(1), locked1);
        stayLocked1.setToValue(1.0);
        stayLocked1.setCycleCount(1);

        FadeTransition ftLocked1Wakeup = new FadeTransition(Duration.millis(1000), locked1);
        ftLocked1Wakeup.setToValue(0.0);
        ftLocked1Wakeup.setCycleCount(1);
        
        TranslateTransition tLocked1Wakeup = new TranslateTransition(Duration.millis(2), locked1);
        tLocked1Wakeup.setToX(sX + 1000);
        tLocked1Wakeup.setFromX(sX + 680);
        tLocked1Wakeup.setCycleCount(1);
        
        final SequentialTransition st1Locked1Wakeup = new SequentialTransition (
            new PauseTransition(Duration.millis(2000)),
            ftLocked1Wakeup
        ); 
        
        final SequentialTransition st2Locked1Wakeup = new SequentialTransition (
            new PauseTransition(Duration.millis(3000)),
            tLocked1Wakeup
        ); 
        
        final SequentialTransition st3Locked1Wakeup = new SequentialTransition (
            new PauseTransition(Duration.millis(1)),
            ftLocked1Wakeup
        ); 
                
        final SequentialTransition st4Locked1Wakeup = new SequentialTransition (
            new PauseTransition(Duration.millis(1000)),
            tLocked1Wakeup
        ); 
         
// LOCKED 2
        
        // image
        StackPane locked2 = new StackPane();        
        ImageView imageLocked2 = new ImageView("/img2/locked2.png");
        locked2.getChildren().add(imageLocked2);
        locked2.setTranslateY(sY + 270);       
        
        // initializing
        FadeTransition initLocked2 = new FadeTransition(Duration.millis(1), locked2);
        initLocked2.setToValue(0.0);
        initLocked2.setCycleCount(1);
        initLocked2.play();
        
        // actions
// LOCKED 2 SLEEP
        final FadeTransition ftLocked2Sleep = new FadeTransition(Duration.millis(1000), locked2);
        ftLocked2Sleep.setToValue(1.0);
        ftLocked2Sleep.setCycleCount(1);
        
        TranslateTransition tLocked2Sleep = new TranslateTransition(Duration.millis(1), locked2);
        tLocked2Sleep.setFromX(sX + 1000);
        tLocked2Sleep.setToX(sX + 680);
        tLocked2Sleep.setCycleCount(1);
                   
// LOCKED 2 WAKEUP
        
        FadeTransition stayLocked2 = new FadeTransition(Duration.millis(1), locked2);
        stayLocked2.setToValue(1.0);
        stayLocked2.setCycleCount(1);
        
        FadeTransition ftLocked2Wakeup = new FadeTransition(Duration.millis(1000), locked2);
        ftLocked2Wakeup.setToValue(0.0);
        ftLocked2Wakeup.setCycleCount(1);
        
        TranslateTransition tLocked2Wakeup = new TranslateTransition(Duration.millis(2), locked2);
        tLocked2Wakeup.setToX(sX + 1000);
        tLocked2Wakeup.setFromX(sX + 680);
        tLocked2Wakeup.setCycleCount(1);
        
        final SequentialTransition st1Locked2Wakeup = new SequentialTransition (
            new PauseTransition(Duration.millis(2000)),
            ftLocked2Wakeup
        ); 
         
        final SequentialTransition st2Locked2Wakeup = new SequentialTransition (
            new PauseTransition(Duration.millis(3000)),
            tLocked2Wakeup
        ); 
        
        final SequentialTransition st3Locked2Wakeup = new SequentialTransition (
            new PauseTransition(Duration.millis(1)),
            ftLocked2Wakeup
        ); 
                
        final SequentialTransition st4Locked2Wakeup = new SequentialTransition (
            new PauseTransition(Duration.millis(1000)),
            tLocked2Wakeup
        ); 
         
// MILK OUT GOING
        
        // image
        StackPane milkOutGoing = new StackPane();
        ImageView imageMilkOutGoing = new ImageView("/img2/milkOut.png");  
        milkOutGoing.getChildren().add(imageMilkOutGoing);
        milkOutGoing.setTranslateY(sY + 406);
        
        // initializing
        FadeTransition initMilkOutGoing = new FadeTransition(Duration.millis(1), milkOutGoing);
        initMilkOutGoing.setFromValue(0.0);
        initMilkOutGoing.setToValue(0.0);
        initMilkOutGoing.setCycleCount(1);
        initMilkOutGoing.play();
        
        // actions
        final FadeTransition ft1MilkOutGoing = new FadeTransition(Duration.millis(400), milkOutGoing);
        ft1MilkOutGoing.setFromValue(0.0);
        ft1MilkOutGoing.setToValue(1.0);
        ft1MilkOutGoing.setCycleCount(1);
        
        final FadeTransition ft2MilkOutGoing = new FadeTransition(Duration.millis(400), milkOutGoing);
        ft2MilkOutGoing.setFromValue(1.0);
        ft2MilkOutGoing.setToValue(0.0);
        ft2MilkOutGoing.setCycleCount(1);
        
        TranslateTransition tMilkOutGoing = new TranslateTransition(Duration.millis(2000), milkOutGoing);
        tMilkOutGoing.setFromX(85);
        tMilkOutGoing.setToX(sX + 315);
        tMilkOutGoing.setCycleCount(1);
            
        final SequentialTransition stMilkOutGoing = new SequentialTransition (    
            new PauseTransition(Duration.millis(2000)),
            ft2MilkOutGoing
        );  
        
// MILK OUT RETURNING        
        
        // image
        StackPane milkOutReturning = new StackPane();
        ImageView imageMilkOutReturning = new ImageView("/img2/milkOut.png");        
        milkOutReturning.getChildren().add(imageMilkOutReturning);
        milkOutReturning.setTranslateY(sY + 406);   
        
        // initializing
        FadeTransition initMilkOutReturning = new FadeTransition(Duration.millis(1), milkOutReturning);
        initMilkOutReturning.setFromValue(0.0);
        initMilkOutReturning.setToValue(0.0);
        initMilkOutReturning.setCycleCount(1);
        initMilkOutReturning.play(); 
        
        // actions
        final FadeTransition ft1MilkOutReturning = new FadeTransition(Duration.millis(400), milkOutReturning);
        ft1MilkOutReturning.setFromValue(0.0);
        ft1MilkOutReturning.setToValue(1.0);
        ft1MilkOutReturning.setCycleCount(1);
        
        final FadeTransition ft2MilkOutReturning = new FadeTransition(Duration.millis(400), milkOutReturning);
        ft2MilkOutReturning.setFromValue(1.0);
        ft2MilkOutReturning.setToValue(0.0);
        ft2MilkOutReturning.setCycleCount(1);
        
        TranslateTransition tMilkOutReturning = new TranslateTransition(Duration.millis(2000), milkOutReturning);
        tMilkOutReturning.setFromX(sX + 255);
        tMilkOutReturning.setToX(25);
        tMilkOutReturning.setCycleCount(1);
        
        final SequentialTransition st1MilkOutReturning = new SequentialTransition (   
            new PauseTransition(Duration.millis(1500)),
            ft1MilkOutReturning
        );  
        
        final SequentialTransition st2MilkOutReturning = new SequentialTransition (   
            new PauseTransition(Duration.millis(1500)),
            tMilkOutReturning
        );  
        
        final SequentialTransition st3MilkOutReturning = new SequentialTransition (   
            new PauseTransition(Duration.millis(3100)),
            ft2MilkOutReturning
        );  
        
// MILK IN 
        
        // image
        ArrayList<StackPane> milkIn = new ArrayList<>();       
        for (int i = 0; i < 36; i++) {
            milkIn.add(new StackPane());
        }
 
        ArrayList<ImageView> imageMilkIn = new ArrayList<>();       
        for (int i = 0; i < 36; i++) {
            imageMilkIn.add(new ImageView("/img2/milkIn.png"));
        }
        
        int X, Y = 0, K = 0;
        for (int i = 0; i < 6; i++) {          
            X = 0; 
            for (int j = 0; j < 6; j++) {
         
                milkIn.get(K).getChildren().add(imageMilkIn.get(K));
                milkIn.get(K).setTranslateX(sX + 365 + X);
                milkIn.get(K).setTranslateY(sY + 151 + Y);
                
                X += 30;             
                K++;   
            }   
            Y += 50;
        }
        
        // initializing
        ArrayList<FadeTransition> initMilkIn = new ArrayList<>();
        for (int i = 0; i < 36; i++) {
            initMilkIn.add(new FadeTransition(Duration.millis(1), milkIn.get(i)));
            initMilkIn.get(i).setFromValue(0.0);
            initMilkIn.get(i).setToValue(0.0);
            initMilkIn.get(i).setCycleCount(1);
            initMilkIn.get(i).play();
        }
        
        // actions
// MILK IN UP
        ArrayList<FadeTransition> ft1MilkInUp = new ArrayList<>();
        ArrayList<SequentialTransition> stMilkInUp = new ArrayList<>();
        
        for (int i = 0; i < 36; i++) {
            ft1MilkInUp.add(new FadeTransition(Duration.millis(400), milkIn.get(i)));
            ft1MilkInUp.get(i).setToValue(1.0);
            ft1MilkInUp.get(i).setCycleCount(1);
                        
            stMilkInUp.add(new SequentialTransition (
                new PauseTransition(Duration.millis(2000)), 
                ft1MilkInUp.get(i)
            ));      
        }

// MILK IN DOWN
        ArrayList<FadeTransition> ft1MilkInDown = new ArrayList<>();
        ArrayList<SequentialTransition> stMilkInDown = new ArrayList<>();
        
        for (int i = 0; i < 36; i++) {
            ft1MilkInDown.add(new FadeTransition(Duration.millis(400), milkIn.get(i)));
            ft1MilkInDown.get(i).setToValue(0.0);
            ft1MilkInDown.get(i).setCycleCount(1);
                        
            stMilkInDown.add(new SequentialTransition (
                new PauseTransition(Duration.millis(1500)), 
                ft1MilkInDown.get(i)
            ));           
        }                 


// TEXT SEMAPHORE
        Text tSemaphore = new Text();
        if(language == 1) tSemaphore.setText("Semaphore");
        else tSemaphore.setText("Semáforo");
        tSemaphore.setFont(Font.font(null, FontWeight.BOLD, 20));
        tSemaphore.setTranslateY(570);
        tSemaphore.setTranslateX(600);
        tSemaphore.setFill(Color.SIENNA);
// TEST SEMAPHORE NUMBER
        Text tSemaphoreN = new Text();
        tSemaphoreN.setText(Integer.toString(semaphore));
        tSemaphoreN.setFont(Font.font(null, FontWeight.BOLD, 20));
        tSemaphoreN.setTranslateY(600);
        tSemaphoreN.setTranslateX(650); 
                
// TEXT PROCESS 1 
        Text tProcess1 = new Text ();
        if(language == 1) tProcess1.setText("Process 1");
        else tProcess1.setText("Processo 1");
        tProcess1.setFont(Font.font(null, FontWeight.BOLD, 20));
        tProcess1.setTranslateY(475);
        tProcess1.setTranslateX(115);
        tProcess1.setFill(Color.SIENNA);
        
        ArrayList<Text> data1 = new ArrayList<>();
        
        int textX = 0;
        int breakFunction = 0;
        
        for (int i = 0; i < 8; i++) {
            data1.add(new Text (data.get(i)));
            
            data1.get(i).setTranslateX(31);
            data1.get(i).setTranslateY(505 + textX);
            data1.get(i).setFont(Font.font(null, FontWeight.NORMAL, 15));
            data1.get(i).setFill(Color.rgb(15, 15, 15));  
            
            breakFunction++;
            if (breakFunction == 3) textX += 24;
            textX += 24;
            
        }
        

// TEXT PROCESS 2 
        Text tProcess2 = new Text ();
        if(language == 1) tProcess2.setText("Process 2");
        else tProcess2.setText("Processo 2");
        
        tProcess2.setFont(Font.font(null, FontWeight.BOLD, 20));
        tProcess2.setTranslateY(475);
        tProcess2.setTranslateX(390);
        tProcess2.setFill(Color.SIENNA);  
        
        ArrayList<Text> data2 = new ArrayList<>();
        
        textX = 0;
        breakFunction = 0;
        
        for (int i = 0; i < 8; i++) {
            data2.add(new Text (data.get(i)));
            
            data2.get(i).setTranslateX(306);
            data2.get(i).setTranslateY(505 + textX);
            data2.get(i).setFont(Font.font(null, FontWeight.NORMAL, 15));
            data2.get(i).setFill(Color.rgb(15, 15, 15));  
            
            breakFunction++;
            if (breakFunction == 3) textX += 24;
            textX += 24;
            
        }

// TABLE PROCESS 1
          
        StackPane table1_0 = new StackPane();
        ImageView imageTable1_0 = new ImageView("/img2/tableInit.png");        
        table1_0.getChildren().add(imageTable1_0);
        table1_0.setTranslateY(485); 
        table1_0.setTranslateX(25);
        
        StackPane table1_1 = new StackPane();
        ImageView imageTable1_1 = new ImageView();
        if(language == 1) imageTable1_1.setImage(new Image("/img2/table1EN.png"));
        else imageTable1_1.setImage(new Image("/img2/table1PT.png"));
        table1_1.getChildren().add(imageTable1_1);
        table1_1.setTranslateY(485); 
        table1_1.setTranslateX(25);
        table1_1.setVisible(false);
        
        StackPane table1_2 = new StackPane();
        ImageView imageTable1_2 = new ImageView();
        if(language == 1) imageTable1_2.setImage(new Image("/img2/table2EN.png"));
        else imageTable1_2.setImage(new Image("/img2/table2PT.png"));
        table1_2.getChildren().add(imageTable1_2);
        table1_2.setTranslateY(485); 
        table1_2.setTranslateX(25);
        table1_2.setVisible(false);
          
        StackPane table1_3 = new StackPane();
        ImageView imageTable1_3 = new ImageView("/img2/table3.png");        
        table1_3.getChildren().add(imageTable1_3);
        table1_3.setTranslateY(485); 
        table1_3.setTranslateX(25);
        table1_3.setVisible(false);
          
        StackPane table1_4 = new StackPane();
        ImageView imageTable1_4 = new ImageView();
        if(language == 1) imageTable1_4.setImage(new Image("/img2/table4EN.png"));
        else imageTable1_4.setImage(new Image("/img2/table4PT.png"));       
        table1_4.getChildren().add(imageTable1_4);
        table1_4.setTranslateY(485); 
        table1_4.setTranslateX(25);
        table1_4.setVisible(false);
       
// TABLE PROCESS 2
       
        StackPane table2_0 = new StackPane();
        ImageView imageTable2_0 = new ImageView("/img2/tableInit.png");        
        table2_0.getChildren().add(imageTable2_0);
        table2_0.setTranslateY(485); 
        table2_0.setTranslateX(300); 
        
        StackPane table2_1 = new StackPane();
        ImageView imageTable2_1 = new ImageView();
        if(language == 1) imageTable2_1.setImage(new Image("/img2/table1EN.png"));
        else imageTable2_1.setImage(new Image("/img2/table1PT.png"));           
        table2_1.getChildren().add(imageTable2_1);
        table2_1.setTranslateY(485); 
        table2_1.setTranslateX(300); 
        table2_1.setVisible(false);
        
        StackPane table2_2 = new StackPane();
        ImageView imageTable2_2 = new ImageView();
        if(language == 1) imageTable2_2.setImage(new Image("/img2/table2EN.png"));
        else imageTable2_2.setImage(new Image("/img2/table2PT.png"));       
        table2_2.getChildren().add(imageTable2_2);
        table2_2.setTranslateY(485); 
        table2_2.setTranslateX(300);
        table2_2.setVisible(false);
         
        StackPane table2_3 = new StackPane();
        ImageView imageTable2_3 = new ImageView("/img2/table3.png");        
        table2_3.getChildren().add(imageTable2_3);
        table2_3.setTranslateY(485); 
        table2_3.setTranslateX(300); 
        table2_3.setVisible(false);
         
        StackPane table2_4 = new StackPane();
        ImageView imageTable2_4 = new ImageView();
        if(language == 1) imageTable2_4.setImage(new Image("/img2/table4EN.png"));
        else imageTable2_4.setImage(new Image("/img2/table4PT.png"));       
        table2_4.getChildren().add(imageTable2_4);
        table2_4.setTranslateY(485); 
        table2_4.setTranslateX(300);        
        table2_4.setVisible(false);
        
// TEXT BALLOON 1
        Text tRead1 = new Text();
        
        tRead1.setFont(Font.font(null, FontWeight.BOLD, 30));
        tRead1.setTranslateY(sY + 144);
        tRead1.setFill(Color.GREY);
        
        final SequentialTransition stRead1 = new SequentialTransition (    
            new PauseTransition(Duration.millis(1100))
        ); 
        
        stRead1.onFinishedProperty().set(new EventHandler<ActionEvent>() {
            @Override 
            public void handle(ActionEvent actionEvent) {

                tRead1.setText("");
                tSemaphoreN.setText(Integer.toString(semaphore));
                table1_2.setVisible(false);
                tSemaphoreN.setFill(Color.BLACK);

            }
        });        
        
// TEXT BALLOON 2
        Text tRead2 = new Text();
        
        tRead2.setFont(Font.font(null, FontWeight.BOLD, 30));
        tRead2.setTranslateY(sY + 344);
        tRead2.setFill(Color.GREY); 
        
        final SequentialTransition stRead2 = new SequentialTransition (    
            new PauseTransition(Duration.millis(1100))
        ); 
        
        stRead2.onFinishedProperty().set(new EventHandler<ActionEvent>() {
            @Override 
            public void handle(ActionEvent actionEvent) {              
                tRead2.setText("");
                tSemaphoreN.setText(Integer.toString(semaphore));
                table2_2.setVisible(false);
                tSemaphoreN.setFill(Color.BLACK);
            }
        });         
        
// SEMAPHORE UP ACTIONS
        
        final SequentialTransition stSemUP = new SequentialTransition (    
            new PauseTransition(Duration.millis(2400))
        ); 
        
        stSemUP.onFinishedProperty().set(new EventHandler<ActionEvent>() {
            @Override 
            public void handle(ActionEvent actionEvent) {
                up1.setDisable(false);
                down1.setDisable(false);
                up2.setDisable(false);
                down2.setDisable(false);
                reset.setDisable(false);
                
                table1_1.setVisible(false);
                table2_1.setVisible(false);
                table1_3.setVisible(false);
                table2_3.setVisible(false);

                if (semaphore == 36){
                    up1.setDisable(true);
                    up2.setDisable(true);
                }
            }
        }); 
        
// SEMAPHORE DOWN ACTION
        
        final SequentialTransition stSemDown = new SequentialTransition (    
            new PauseTransition(Duration.millis(3510))
        ); 
        
        stSemDown.onFinishedProperty().set(new EventHandler<ActionEvent>() {
            @Override 
            public void handle(ActionEvent actionEvent) {
                up1.setDisable(false);
                down1.setDisable(false);
                up2.setDisable(false);
                down2.setDisable(false);
                reset.setDisable(false);
                
                table1_4.setVisible(false);
                table2_4.setVisible(false);

            }
        });
                                     
//---------------------
        
        root.getChildren().addAll(imageBackground);
        root.getChildren().addAll(tSemaphore, tSemaphoreN);       
        root.getChildren().addAll(cat1Going, cat2Returning, cat1Process, cat2Going, cat1Returning, cat2Process);
        root.getChildren().addAll(up1, up2, down1, down2, reset);
        root.getChildren().addAll(refrigerator, milkOutGoing, milkOutReturning, balloon1, balloon2, tRead1, tRead2, locked2, locked1);
        root.getChildren().addAll(table1_0, table1_1, table1_2, table1_3, table1_4, table2_0, table2_1, table2_2, table2_3, table2_4, tProcess1, tProcess2);
        root.getChildren().addAll(infoProcess1, infoProcess2, infoSemaphores, nowuseeme);
        
        for (int i = 0; i < 8; i++) {
            root.getChildren().addAll(data1.get(i), data2.get(i));
        }

        for (int i = 0; i < 36; i++) {
            root.getChildren().add(milkIn.get(i));
        }
              
        stage.setScene(scene);
        stage.setWidth(756);
        stage.setHeight(748);
        stage.show();

      
// BUTTONS ACTIONS
        
        up1.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                
                up1.setDisable(true);
                down1.setDisable(true);
                up2.setDisable(true);
                down2.setDisable(true);
                reset.setDisable(true);
                
                table1_1.setVisible(true);
                
                // Cat 1 Going
                ft1Cat1Going.play();
                tCat1Going.play();
                stCat1Going.play();
                
                // Milk Out Going
                ft1MilkOutGoing.play();
                tMilkOutGoing.play();
                stMilkOutGoing.play();
                              
                if (semaphore == 0 ){

                        if (cat2blocked == true){

                            cat2blocked = false;
                            stayLocked2.play();
                            st1Locked2Wakeup.play();
                            st2Locked2Wakeup.play();
                            
                            st2Locked2Wakeup.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                                @Override 
                                public void handle(ActionEvent actionEvent) {
                                    cat2Process.setVisible(true);
                                    balloon2.setVisible(true);
                                    up2.setVisible(true);
                                    down2.setVisible(true);
                                }
                            });

                        }else{
                            
                            // Milk In UP
                            stMilkInUp.get(semaphore).play();
                            
                            semaphore++;
                        } 
                }else{
                            
                    // Milk In UP
                    stMilkInUp.get(semaphore).play();

                    semaphore++;
                }     
                
                // Semaphore Up
                stSemUP.play();
     
            tSemaphoreN.setText(Integer.toString(semaphore));
            
            }
        });
        
        up2.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {  
                
                up1.setDisable(true);
                down1.setDisable(true);
                up2.setDisable(true);
                down2.setDisable(true);
                reset.setDisable(true);
                
                table2_1.setVisible(true);
                
                // Cat 2 Going
                ft1Cat2Going.play();
                tCat2Going.play();
                stCat2Going.play();
                
                // Milk Out Going
                ft1MilkOutGoing.play();
                tMilkOutGoing.play();
                stMilkOutGoing.play();
                                
                if (semaphore == 0 ){

                        if (cat1blocked == true){

                            cat1blocked = false;
                            stayLocked1.play();
                            st1Locked1Wakeup.play();
                            st2Locked1Wakeup.play();
                            
                            st2Locked1Wakeup.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                                @Override 
                                public void handle(ActionEvent actionEvent) {
                                    cat1Process.setVisible(true);
                                    balloon1.setVisible(true);
                                    up1.setVisible(true);
                                    down1.setVisible(true);
                                }
                            });
                            

                        }else{
                            
                            // Milk In UP
                            stMilkInUp.get(semaphore).play();
                            
                            semaphore++;
                        } 
                }else{
                            
                    // Milk In UP
                    stMilkInUp.get(semaphore).play();

                    semaphore++;
                }
                
                // Semaphore Up
                stSemUP.play();
                
            tSemaphoreN.setText(Integer.toString(semaphore));    
            }
        });
        
        down1.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                                
                up1.setDisable(true);
                down1.setDisable(true);
                up2.setDisable(true);
                down2.setDisable(true);
                reset.setDisable(true);
                
                table1_2.setVisible(true);
                tSemaphoreN.setFill(Color.BROWN);
                
                if (semaphore >= 10) tRead1.setTranslateX(sX + 722);
                else tRead1.setTranslateX(sX + 732);
                
                tRead1.setText(Integer.toString(semaphore));
                stRead1.play();
                
                if (semaphore == 0){

                    cat1blocked = true;
                    
                    final SequentialTransition delayBlock1_1 = new SequentialTransition (new PauseTransition(Duration.millis(1100)));
                    delayBlock1_1.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                        @Override 
                        public void handle(ActionEvent actionEvent) {     
                            
                         table1_3.setVisible(true);
                         
                         cat1Process.setVisible(false);
                         balloon1.setVisible(false);
                         up1.setVisible(false);
                         down1.setVisible(false);
                                                                      
                        }
                    }); 
                    delayBlock1_1.play();
                    
                    final SequentialTransition block1 = new SequentialTransition (    
                        new PauseTransition(Duration.millis(1010)),
                        tLocked1Sleep,
                        ftLocked1Sleep
                    ); 
                    
                    block1.play();
                     
                    block1.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                        @Override 
                        public void handle(ActionEvent actionEvent) {     
                            
                        up1.setDisable(false);
                        down1.setDisable(false);
                        up2.setDisable(false);
                        down2.setDisable(false);
                        reset.setDisable(false); 
                                                                      
                        }
                    }); 

                }else{

                    semaphore--;
                    
                    final SequentialTransition delayBlock1_2 = new SequentialTransition (new PauseTransition(Duration.millis(1010)));
                    delayBlock1_2.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                        @Override 
                        public void handle(ActionEvent actionEvent) {     
                            
                         table1_4.setVisible(true);
                                                                      
                        }
                    }); 
                    delayBlock1_2.play();
         
                    // Milk Out Returning
                    initMilkOutReturning.play();
                    st1MilkOutReturning.play();
                    st2MilkOutReturning.play();
                    st3MilkOutReturning.play();

                    // Cat 1 Returning
                    initCat1Returning.play();                
                    st1Cat1Returning.play();
                    st2Cat1Returning.play();
                    st3Cat1Returning.play();

                    // Milk In Down
                    stMilkInDown.get(semaphore).play();
                    
                    // Semaphore Down
                    stSemDown.play(); 

                }
               
            }
        });
        
        down2.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {

                up1.setDisable(true);
                down1.setDisable(true);
                up2.setDisable(true);
                down2.setDisable(true);
                reset.setDisable(true);
                
                table2_2.setVisible(true);
                tSemaphoreN.setFill(Color.BROWN);
                
                if (semaphore >= 10) tRead2.setTranslateX(sX + 722);
                else tRead2.setTranslateX(sX + 732);
                
                tRead2.setText(Integer.toString(semaphore));
                stRead2.play();
                

                if (semaphore == 0){
                    
                    cat2blocked = true;
                    
                    final SequentialTransition delayBlock2_1 = new SequentialTransition (new PauseTransition(Duration.millis(1100)));
                    delayBlock2_1.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                        @Override 
                        public void handle(ActionEvent actionEvent) {     
                            
                        table2_3.setVisible(true);

                        cat2Process.setVisible(false);
                        balloon2.setVisible(false);
                        up2.setVisible(false);
                        down2.setVisible(false);
                                                                      
                        }
                    }); 
                    delayBlock2_1.play();
                    
                    final SequentialTransition block2 = new SequentialTransition (    
                        new PauseTransition(Duration.millis(1010)),
                        tLocked2Sleep,
                        ftLocked2Sleep
                    ); 
                    block2.play();
                    
                    block2.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                        @Override 
                        public void handle(ActionEvent actionEvent) {     
                            
                        up1.setDisable(false);
                        down1.setDisable(false);
                        up2.setDisable(false);
                        down2.setDisable(false);
                        reset.setDisable(false); 
                        
                        }
                    }); 

                }else{

                    semaphore--;
                    
                    final SequentialTransition delayBlock2_2 = new SequentialTransition (new PauseTransition(Duration.millis(1010)));
                    delayBlock2_2.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                        @Override 
                        public void handle(ActionEvent actionEvent) {     
                            
                         table2_4.setVisible(true);
                                                                      
                        }
                    }); 
                    delayBlock2_2.play();
                              
                    // Milk Out Returning
                    initMilkOutReturning.play();
                    st1MilkOutReturning.play();
                    st2MilkOutReturning.play();
                    st3MilkOutReturning.play();

                    // Cat 2 Returning
                    initCat2Returning.play();                
                    st1Cat2Returning.play();
                    st2Cat2Returning.play();
                    st3Cat2Returning.play();

                    // Milk In Down
                    stMilkInDown.get(semaphore).play();

                    // Semaphore Down
                    stSemDown.play();
                }
                
            }
        });
                        
        reset.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                
                up1.setDisable(false);
                down1.setDisable(false);
                up2.setDisable(false);
                down2.setDisable(false);
                reset.setDisable(false); 

                if (cat1blocked == true){
                    st3Locked1Wakeup.play();
                    st4Locked1Wakeup.play();
                    cat1blocked = false;
                    
                    st4Locked1Wakeup.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                        @Override 
                        public void handle(ActionEvent actionEvent) {     
                            
                            cat1Process.setVisible(true);
                            balloon1.setVisible(true);
                            up1.setVisible(true);
                            down1.setVisible(true);
                                                                      
                        }
                    }); 
                }
                
                if (cat2blocked == true){                
                    st3Locked2Wakeup.play();
                    st4Locked2Wakeup.play();
                    cat2blocked = false;
                    
                    st4Locked2Wakeup.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                        @Override 
                        public void handle(ActionEvent actionEvent) {     
                            
                            cat2Process.setVisible(true);
                            balloon2.setVisible(true);
                            up2.setVisible(true);
                            down2.setVisible(true);
                                                                      
                        }
                    }); 

                }
                
                for (int i = 0; i < 36; i++) {
                    initMilkIn.get(i).setFromValue(0.0);
                    initMilkIn.get(i).setToValue(0.0);
                    initMilkIn.get(i).setCycleCount(1);
                    initMilkIn.get(i).play();
                }
                
                semaphore = 0;
                
                tSemaphoreN.setText(Integer.toString(semaphore));
                
                table1_1.setVisible(false);
                table1_2.setVisible(false);
                table1_3.setVisible(false);
                table1_4.setVisible(false);
                table2_1.setVisible(false);
                table2_2.setVisible(false);
                table2_3.setVisible(false);
                table2_4.setVisible(false);

            }
        }); 
    }
    
    public static void main(String[] args) {
        launch(args);
    }
    
}