package mutex;

import java.util.ArrayList;
import javafx.animation.FadeTransition;
import javafx.animation.PauseTransition;
import javafx.animation.SequentialTransition;
import javafx.animation.TranslateTransition;
import static javafx.application.Application.launch;
import javafx.scene.Group;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.text.Text;
import javafx.util.Duration;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.effect.DropShadow;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

public class Mutex extends Application {
    
    public int semaphore;
    public boolean cat1blocked, cat2blocked;
    public boolean cat1Use, cat2Use;
    
    public int language;
    
    StackPane cat2Going, table1_0, table1_1, table1_2, table1_3, milkOutInit, cat1Going, locked2, locked1, table2_1, table2_2, table2_3, table2_4;
    
    FadeTransition ft12Cat2Going, ft1MilkOutReturning2, ft1Cat1Returning, ft1MilkOutReturning1, ft12Cat1Going, ft1Cat2Returning;
    TranslateTransition tMilkOutReturning2, tCat2Returning, tCat1Returning, tMilkOutReturning1;
    SequentialTransition st5Cat2Going, st3Cat2Going, st2Cat2Going, st3MilkOutGoing2, st2MilkOutGoing2, st1MilkOutGoing2, stMilkOutReturning2, stCat2Returning, stCat1Returning, stMilkOutReturning1, st1MilkOutGoing1, st2MilkOutGoing1, st3MilkOutGoing1, st2Cat1Going, st3Cat1Going, st5Cat1Going;

    Text tSemaphoreN;
    
    Button btn1, btn2;
    
    public ArrayList<String> data = new ArrayList<>();
    
    public Mutex(Stage stage, int lang){
        language = lang;
        start(stage);
    }
    
    @Override
    public void start(Stage stage) {
        
        //language = 1;
        // 0 = PT-BR
        // 1 = EN
        
        semaphore = 1;
        cat1Use = false;
        cat2Use = false;
        
        if (language == 1){
            data.add("1   down(mutex);");
            data.add("2   ACCESS CRITICAL SECTION");
            data.add("3   up(mutex);");

            stage.setTitle("Mutex Example");
        }
        else{
           data.add("1   down(mutex);");
           data.add("2   ACESSAR REGIÃO CRÍTICA");
           data.add("3   up(mutex);");

           stage.setTitle("Exemplo de Mutex");           
            
        }
        Group root = new Group();
        final Scene scene = new Scene(root);

// BACKGROUND               
        StackPane background = new StackPane();
        ImageView imageBackground = new ImageView("/img/background.png");        
        background.getChildren().add(imageBackground);
       
 // BUTTONS       
        
        btn1 = new Button();
        if (language == 1) btn1.setText("Use");
        else btn1.setText("Usar");
        btn1.setTranslateX(35);
        btn1.setTranslateY(110);
        
        btn2 = new Button();
        if (language == 1) btn2.setText("Use");
        else btn2.setText("Usar");
        btn2.setTranslateX(520);
        btn2.setTranslateY(110);
                       
// CAT 1 GOING
        
        // image
        cat1Going = new StackPane();
        ImageView imageCat1Going = new ImageView("/img/cat1Going.png");        
        cat1Going.getChildren().add(imageCat1Going);
        cat1Going.setTranslateY(50);
        cat1Going.setTranslateX(25);
        
        // actions
        final FadeTransition ft1Cat1Going = new FadeTransition(Duration.millis(1), cat1Going);
        ft1Cat1Going.setFromValue(0.0);
        ft1Cat1Going.setToValue(1.0);
        ft1Cat1Going.setCycleCount(1);
        
        ft12Cat1Going = new FadeTransition(Duration.millis(400), cat1Going);
        ft12Cat1Going.setFromValue(0.0);
        ft12Cat1Going.setToValue(1.0);
        ft12Cat1Going.setCycleCount(1);
        
        final FadeTransition ft2Cat1Going = new FadeTransition(Duration.millis(1), cat1Going);
        ft2Cat1Going.setFromValue(1.0);
        ft2Cat1Going.setToValue(0.0);
        ft2Cat1Going.setCycleCount(1);
        
        TranslateTransition tCat1Going = new TranslateTransition(Duration.millis(2000), cat1Going);
        tCat1Going.setFromX(25);
        tCat1Going.setToX(220);
        tCat1Going.setCycleCount(1);
        
        final SequentialTransition stCat1Going = new SequentialTransition (
            new PauseTransition(Duration.millis(2000)),
            ft2Cat1Going
        );
        
// Cat Going 1x2        
                
        // actions
        final FadeTransition ft1Cat1Going2 = new FadeTransition(Duration.millis(1), cat1Going);
        ft1Cat1Going2.setToValue(1.0);
        ft1Cat1Going2.setCycleCount(1);
        
        final FadeTransition ft2Cat1Going2 = new FadeTransition(Duration.millis(1), cat1Going);
        ft2Cat1Going2.setToValue(0.0);
        ft2Cat1Going2.setCycleCount(1);
        
        final FadeTransition ft3Cat1Going2 = new FadeTransition(Duration.millis(400), cat1Going);
        ft3Cat1Going2.setToValue(0.0);
        ft3Cat1Going2.setCycleCount(1);
                
        TranslateTransition tCat1Going2 = new TranslateTransition(Duration.millis(2000), cat1Going);
        tCat1Going2.setFromX(25);
        tCat1Going2.setToX(220);
        tCat1Going2.setCycleCount(1);
        
        
        st2Cat1Going = new SequentialTransition (
            new PauseTransition(Duration.millis(7000)),
            ft1Cat1Going2
        );
        
        st3Cat1Going = new SequentialTransition (
            new PauseTransition(Duration.millis(7000)),
            tCat1Going2
        );
                
        final SequentialTransition st4Cat1Going = new SequentialTransition (
            new PauseTransition(Duration.millis(9000)),
            ft2Cat1Going2
        );
        
        st5Cat1Going = new SequentialTransition (
            new PauseTransition(Duration.millis(9000)),
            ft3Cat1Going2
        );
            
// CAT 1 RETURNING        
        
        // image
        StackPane cat1Returning = new StackPane();
        ImageView imageCat1Returning = new ImageView("/img/cat1Returning.png");
        cat1Returning.getChildren().add(imageCat1Returning); 
        cat1Returning.setTranslateY(50);
        
        // initializing
        FadeTransition initCat1Returning = new FadeTransition(Duration.millis(1), cat1Returning);
        initCat1Returning.setFromValue(0.0);
        initCat1Returning.setToValue(0.0);
        initCat1Returning.setCycleCount(1);
        initCat1Returning.play();
        
        // actions
        ft1Cat1Returning = new FadeTransition(Duration.millis(1), cat1Returning);
        ft1Cat1Returning.setToValue(1.0);
        ft1Cat1Returning.setCycleCount(1);
        
        final FadeTransition ft2Cat1Returning = new FadeTransition(Duration.millis(1), cat1Returning);
        ft2Cat1Returning.setToValue(0.0);
        ft2Cat1Returning.setCycleCount(1);
        
        tCat1Returning = new TranslateTransition(Duration.millis(2000), cat1Returning);
        tCat1Returning.setFromX(220);
        tCat1Returning.setToX(25);
        tCat1Returning.setCycleCount(1);
                
        stCat1Returning = new SequentialTransition (
            new PauseTransition(Duration.millis(7000)),
            ft2Cat1Returning
        );
                
// CAT 2 GOING
        
        // image
        cat2Going = new StackPane();
        ImageView imageCat2Going = new ImageView("/img/cat2Returning.png");        
        cat2Going.getChildren().add(imageCat2Going);
        cat2Going.setTranslateY(50);
        cat2Going.setTranslateX(500);
        
        // actions
        final FadeTransition ft1Cat2Going = new FadeTransition(Duration.millis(1), cat2Going);
        ft1Cat2Going.setFromValue(0.0);
        ft1Cat2Going.setToValue(1.0);
        ft1Cat2Going.setCycleCount(1);
        
        ft12Cat2Going = new FadeTransition(Duration.millis(400), cat2Going);
        ft12Cat2Going.setFromValue(0.0);
        ft12Cat2Going.setToValue(1.0);
        ft12Cat2Going.setCycleCount(1);
        
        final FadeTransition ft2Cat2Going = new FadeTransition(Duration.millis(1), cat2Going);
        ft2Cat2Going.setFromValue(1.0);
        ft2Cat2Going.setToValue(0.0);
        ft2Cat2Going.setCycleCount(1);
        
        TranslateTransition tCat2Going = new TranslateTransition(Duration.millis(2000), cat2Going);
        tCat2Going.setFromX(500);
        tCat2Going.setToX(310);
        tCat2Going.setCycleCount(1);
        
        final SequentialTransition stCat2Going = new SequentialTransition (
            new PauseTransition(Duration.millis(2000)),
            ft2Cat2Going
        );
        
// Cat Going 2x2        
                
        // actions
        final FadeTransition ft1Cat2Going2 = new FadeTransition(Duration.millis(1), cat2Going);
        ft1Cat2Going2.setToValue(1.0);
        ft1Cat2Going2.setCycleCount(1);
        
        final FadeTransition ft2Cat2Going2 = new FadeTransition(Duration.millis(1), cat2Going);
        ft2Cat2Going2.setToValue(0.0);
        ft2Cat2Going2.setCycleCount(1);
        
        final FadeTransition ft3Cat2Going2 = new FadeTransition(Duration.millis(400), cat2Going);
        ft3Cat2Going2.setToValue(0.0);
        ft3Cat2Going2.setCycleCount(1);
                
        TranslateTransition tCat2Going2 = new TranslateTransition(Duration.millis(2000), cat2Going);
        tCat2Going2.setFromX(500);
        tCat2Going2.setToX(310);
        tCat2Going2.setCycleCount(1);
        
        
        st2Cat2Going = new SequentialTransition (
            new PauseTransition(Duration.millis(7000)),
            ft1Cat2Going2
        );
        
        st3Cat2Going = new SequentialTransition (
            new PauseTransition(Duration.millis(7000)),
            tCat2Going2
        );
                
        final SequentialTransition st4Cat2Going = new SequentialTransition (
            new PauseTransition(Duration.millis(9000)),
            ft2Cat2Going2
        );
        
        st5Cat2Going = new SequentialTransition (
            new PauseTransition(Duration.millis(9000)),
            ft3Cat2Going2
        );
            
// CAT 2 RETURNING        
        
        // image
        StackPane cat2Returning = new StackPane();
        ImageView imageCat2Returning = new ImageView("/img/cat2Going.png");
        cat2Returning.getChildren().add(imageCat2Returning); 
        cat2Returning.setTranslateY(50);
        
        // initializing
        FadeTransition initCat2Returning = new FadeTransition(Duration.millis(1), cat2Returning);
        initCat2Returning.setFromValue(0.0);
        initCat2Returning.setToValue(0.0);
        initCat2Returning.setCycleCount(1);
        initCat2Returning.play();
        
        // actions
        ft1Cat2Returning = new FadeTransition(Duration.millis(1), cat2Returning);
        ft1Cat2Returning.setToValue(1.0);
        ft1Cat2Returning.setCycleCount(1);
        
        final FadeTransition ft2Cat2Returning = new FadeTransition(Duration.millis(1), cat2Returning);
        ft2Cat2Returning.setToValue(0.0);
        ft2Cat2Returning.setCycleCount(1);
        
        tCat2Returning = new TranslateTransition(Duration.millis(2000), cat2Returning);
        tCat2Returning.setFromX(310);
        tCat2Returning.setToX(500);
        tCat2Returning.setCycleCount(1);
                
        stCat2Returning = new SequentialTransition (
            new PauseTransition(Duration.millis(7000)),
            ft2Cat2Returning
        );        
   
// LOCKED 1
        
        // image
        locked1 = new StackPane();
        ImageView imageLocked1 = new ImageView("/img/locked1.png");
        locked1.getChildren().add(imageLocked1);
        locked1.setTranslateY(-25);
        locked1.setTranslateX(222);
        
        locked1.setVisible(false);        
         
// LOCKED 2
        
        // image
        locked2 = new StackPane();        
        ImageView imageLocked2 = new ImageView("/img/locked2.png");
        locked2.getChildren().add(imageLocked2);
        locked2.setTranslateY(-25);
        locked2.setTranslateX(320);
        
        locked2.setVisible(false);
        
// MILK     
        // image
        milkOutInit = new StackPane();
        ImageView imageMilkOutInit = new ImageView("/img/milkOut.png");  
        milkOutInit.getChildren().add(imageMilkOutInit);
        milkOutInit.setTranslateY(50);
        milkOutInit.setTranslateX(285);
        
// MILK OUT GOING 1
        
        // image
        StackPane milkOutGoing1 = new StackPane();
        ImageView imageMilkOutGoing1 = new ImageView("/img/milkOut.png");  
        milkOutGoing1.getChildren().add(imageMilkOutGoing1);
        milkOutGoing1.setTranslateY(50);
        
        // initializing
        FadeTransition initMilkOutGoing1 = new FadeTransition(Duration.millis(1), milkOutGoing1);
        initMilkOutGoing1.setFromValue(0.0);
        initMilkOutGoing1.setToValue(0.0);
        initMilkOutGoing1.setCycleCount(1);
        initMilkOutGoing1.play();
        
        // actions
        final FadeTransition ft1MilkOutGoing1 = new FadeTransition(Duration.millis(1), milkOutGoing1);
        ft1MilkOutGoing1.setToValue(1.0);
        ft1MilkOutGoing1.setCycleCount(1);
        
        final FadeTransition ft2MilkOutGoing1 = new FadeTransition(Duration.millis(1), milkOutGoing1);
        ft2MilkOutGoing1.setToValue(0.0);
        ft2MilkOutGoing1.setCycleCount(1);
        
        TranslateTransition tMilkOutGoing1 = new TranslateTransition(Duration.millis(2000), milkOutGoing1);
        tMilkOutGoing1.setFromX(90);
        tMilkOutGoing1.setToX(285);
        tMilkOutGoing1.setCycleCount(1);
        
        st1MilkOutGoing1 = new SequentialTransition (    
            new PauseTransition(Duration.millis(7000)),
            ft1MilkOutGoing1
        );          
        
        st2MilkOutGoing1 = new SequentialTransition (    
            new PauseTransition(Duration.millis(7000)),
            tMilkOutGoing1
        );  
        
        st3MilkOutGoing1 = new SequentialTransition (    
            new PauseTransition(Duration.millis(9400)),
            ft2MilkOutGoing1
        );  
                
// MILK OUT RETURNING 1        
        
        // image
        StackPane milkOutReturning1 = new StackPane();
        ImageView imageMilkOutReturning1 = new ImageView("/img/milkOut.png");        
        milkOutReturning1.getChildren().add(imageMilkOutReturning1);
        milkOutReturning1.setTranslateY(50);   
        
        // initializing
        FadeTransition initMilkOutReturning1 = new FadeTransition(Duration.millis(1), milkOutReturning1);
        initMilkOutReturning1.setFromValue(0.0);
        initMilkOutReturning1.setToValue(0.0);
        initMilkOutReturning1.setCycleCount(1);
        initMilkOutReturning1.play(); 
        
        // actions
        ft1MilkOutReturning1 = new FadeTransition(Duration.millis(1), milkOutReturning1);
        ft1MilkOutReturning1.setToValue(1.0);
        ft1MilkOutReturning1.setCycleCount(1);
        
        final FadeTransition ft2MilkOutReturning1 = new FadeTransition(Duration.millis(1), milkOutReturning1);
        ft2MilkOutReturning1.setToValue(0.0);
        ft2MilkOutReturning1.setCycleCount(1);
        
        tMilkOutReturning1 = new TranslateTransition(Duration.millis(2000), milkOutReturning1);
        tMilkOutReturning1.setFromX(195);
        tMilkOutReturning1.setToX(0);
        tMilkOutReturning1.setCycleCount(1);
        
        stMilkOutReturning1 = new SequentialTransition (   
            new PauseTransition(Duration.millis(7000)),
            ft2MilkOutReturning1
        );  

// MILK OUT GOING 2
        
        // image
        StackPane milkOutGoing2 = new StackPane();
        ImageView imageMilkOutGoing2 = new ImageView("/img/milkOut.png");  
        milkOutGoing2.getChildren().add(imageMilkOutGoing2);
        milkOutGoing2.setTranslateY(50);
        
        // initializing
        FadeTransition initMilkOutGoing2 = new FadeTransition(Duration.millis(1), milkOutGoing2);
        initMilkOutGoing2.setFromValue(0.0);
        initMilkOutGoing2.setToValue(0.0);
        initMilkOutGoing2.setCycleCount(1);
        initMilkOutGoing2.play();
        
        // actions
        final FadeTransition ft1MilkOutGoing2 = new FadeTransition(Duration.millis(1), milkOutGoing2);
        ft1MilkOutGoing2.setToValue(1.0);
        ft1MilkOutGoing2.setCycleCount(1);
        
        final FadeTransition ft2MilkOutGoing2 = new FadeTransition(Duration.millis(1), milkOutGoing2);
        ft2MilkOutGoing2.setToValue(0.0);
        ft2MilkOutGoing2.setCycleCount(1);
        
        TranslateTransition tMilkOutGoing2 = new TranslateTransition(Duration.millis(2000), milkOutGoing2);
        tMilkOutGoing2.setFromX(475);
        tMilkOutGoing2.setToX(285);
        tMilkOutGoing2.setCycleCount(1);
        
        st1MilkOutGoing2 = new SequentialTransition (    
            new PauseTransition(Duration.millis(7000)),
            ft1MilkOutGoing2
        );          
        
        st2MilkOutGoing2 = new SequentialTransition (    
            new PauseTransition(Duration.millis(7000)),
            tMilkOutGoing2
        );  
        
        st3MilkOutGoing2 = new SequentialTransition (    
            new PauseTransition(Duration.millis(9400)),
            ft2MilkOutGoing2
        );  
                
// MILK OUT RETURNING 2        
        
        // image
        StackPane milkOutReturning2 = new StackPane();
        ImageView imageMilkOutReturning2 = new ImageView("/img/milkOut.png");        
        milkOutReturning2.getChildren().add(imageMilkOutReturning2);
        milkOutReturning2.setTranslateY(50);   
        
        // initializing
        FadeTransition initMilkOutReturning2 = new FadeTransition(Duration.millis(1), milkOutReturning2);
        initMilkOutReturning2.setFromValue(0.0);
        initMilkOutReturning2.setToValue(0.0);
        initMilkOutReturning2.setCycleCount(1);
        initMilkOutReturning2.play(); 
        
        // actions
        ft1MilkOutReturning2 = new FadeTransition(Duration.millis(1), milkOutReturning2);
        ft1MilkOutReturning2.setToValue(1.0);
        ft1MilkOutReturning2.setCycleCount(1);
        
        final FadeTransition ft2MilkOutReturning2 = new FadeTransition(Duration.millis(1), milkOutReturning2);
        ft2MilkOutReturning2.setToValue(0.0);
        ft2MilkOutReturning2.setCycleCount(1);
        
        tMilkOutReturning2 = new TranslateTransition(Duration.millis(2000), milkOutReturning2);
        tMilkOutReturning2.setFromX(375);
        tMilkOutReturning2.setToX(565);
        tMilkOutReturning2.setCycleCount(1);
        
        stMilkOutReturning2 = new SequentialTransition (   
            new PauseTransition(Duration.millis(7000)),
            ft2MilkOutReturning2
        );          
        
// TEXT SEMAPHORE
        Text tSemaphore = new Text();
        if (language == 1) tSemaphore.setText("Semaphore");
        else tSemaphore.setText("Semáforo");
        tSemaphore.setFont(Font.font(null, FontWeight.BOLD, 20));
        tSemaphore.setTranslateY(205);
        tSemaphore.setTranslateX(600);
        tSemaphore.setFill(Color.SIENNA);
// TEST SEMAPHORE NUMBER
        tSemaphoreN = new Text();
        tSemaphoreN.setText(Integer.toString(semaphore));
        tSemaphoreN.setFont(Font.font(null, FontWeight.BOLD, 20));
        tSemaphoreN.setTranslateY(235);
        tSemaphoreN.setTranslateX(650); 
                
// TEXT PROCESS 1 
        Text tProcess1 = new Text ();
        if (language == 1) tProcess1.setText("Process 1");
        else tProcess1.setText("Processo 1");        
        tProcess1.setFont(Font.font(null, FontWeight.BOLD, 20));
        tProcess1.setTranslateY(170);
        tProcess1.setTranslateX(115);
        tProcess1.setFill(Color.SIENNA);
        
        ArrayList<Text> data1 = new ArrayList<>();
        
        int textX = 0;
        
        for (int i = 0; i < 3; i++) {
            data1.add(new Text (data.get(i)));
            
            data1.get(i).setTranslateX(31);
            data1.get(i).setTranslateY(200 + textX);
            data1.get(i).setFont(Font.font(null, FontWeight.NORMAL, 14));
            data1.get(i).setFill(Color.rgb(15, 15, 15));  
            
            textX += 24;
            
        }
        

// TEXT PROCESS 2 
        Text tProcess2 = new Text ();
        if (language == 1) tProcess2.setText("Process 2");
        else tProcess2.setText("Processo 2");         
        tProcess2.setFont(Font.font(null, FontWeight.BOLD, 20));
        tProcess2.setTranslateY(170);
        tProcess2.setTranslateX(390);
        tProcess2.setFill(Color.SIENNA);  
        
        ArrayList<Text> data2 = new ArrayList<>();
        
        textX = 0;
        
        for (int i = 0; i < 3; i++) {
            data2.add(new Text (data.get(i)));
            
            data2.get(i).setTranslateX(306);
            data2.get(i).setTranslateY(200 + textX);
            data2.get(i).setFont(Font.font(null, FontWeight.NORMAL, 14));
            data2.get(i).setFill(Color.rgb(15, 15, 15));  
            
            textX += 24;
            
        }

// TABLE PROCESS 1
          
        table1_0 = new StackPane();
        ImageView imageTable1_0 = new ImageView("/img/tableInit.png");        
        table1_0.getChildren().add(imageTable1_0);
        table1_0.setTranslateY(180); 
        table1_0.setTranslateX(25);
        
        table1_1 = new StackPane();
        ImageView imageTable1_1 = new ImageView("/img/table1.png");        
        table1_1.getChildren().add(imageTable1_1);
        table1_1.setTranslateY(180); 
        table1_1.setTranslateX(25);
        table1_1.setVisible(false);
        
        table1_2 = new StackPane();
        ImageView imageTable1_2 = new ImageView("/img/table2.png");        
        table1_2.getChildren().add(imageTable1_2);
        table1_2.setTranslateY(180); 
        table1_2.setTranslateX(25);
        table1_2.setVisible(false);
          
        table1_3 = new StackPane();
        ImageView imageTable1_3 = new ImageView("/img/table3.png");        
        table1_3.getChildren().add(imageTable1_3);
        table1_3.setTranslateY(180); 
        table1_3.setTranslateX(25);
        table1_3.setVisible(false);
          
       
// TABLE PROCESS 2
       
        StackPane table2_0 = new StackPane();
        ImageView imageTable2_0 = new ImageView("/img/tableInit.png");        
        table2_0.getChildren().add(imageTable2_0);
        table2_0.setTranslateY(180); 
        table2_0.setTranslateX(300); 
        
        table2_1 = new StackPane();
        ImageView imageTable2_1 = new ImageView("/img/table1.png");        
        table2_1.getChildren().add(imageTable2_1);
        table2_1.setTranslateY(180); 
        table2_1.setTranslateX(300); 
        table2_1.setVisible(false);
        
        table2_2 = new StackPane();
        ImageView imageTable2_2 = new ImageView("/img/table2.png");        
        table2_2.getChildren().add(imageTable2_2);
        table2_2.setTranslateY(180); 
        table2_2.setTranslateX(300);
        table2_2.setVisible(false);
         
        table2_3 = new StackPane();
        ImageView imageTable2_3 = new ImageView("/img/table3.png");        
        table2_3.getChildren().add(imageTable2_3);
        table2_3.setTranslateY(180); 
        table2_3.setTranslateX(300); 
        table2_3.setVisible(false);
        
// INFO
        
        Button nowuseeme = new Button("Info");
        nowuseeme.setTranslateY(155);
        nowuseeme.setTranslateX(690); 
              
        nowuseeme.setFocusTraversable(false);
     
        Text infoProcess1 = new Text ();
        if(language == 1) infoProcess1.setText("Process 1");
        else infoProcess1.setText("Processo 1");
        infoProcess1.setFont(Font.font(null, FontWeight.BOLD, 20));
        infoProcess1.setTranslateX(10);
        infoProcess1.setTranslateY(40);
        infoProcess1.setFill(Color.GREY);  
        infoProcess1.setVisible(false);
        
        Text infoProcess2 = new Text ();
        if(language == 1) infoProcess2.setText("Process 2");
        else infoProcess2.setText("Processo 2");
        infoProcess2.setFont(Font.font(null, FontWeight.BOLD, 20));
        infoProcess2.setTranslateX(480);
        infoProcess2.setTranslateY(40);
        infoProcess2.setFill(Color.GREY);  
        infoProcess2.setVisible(false);
                    
        Text infoSemaphores = new Text ();
        infoSemaphores.setText("Mutex");
        infoSemaphores.setFont(Font.font(null, FontWeight.BOLD, 20));
        infoSemaphores.setTranslateX(270);
        infoSemaphores.setTranslateY(40);
        infoSemaphores.setFill(Color.GREY);  
        infoSemaphores.setVisible(false); 
        
        nowuseeme.setOnMouseEntered(evt -> {   
            
            DropShadow shadow = new DropShadow();
            shadow.setColor(Color.SIENNA);
            shadow.setRadius(20.0);           
            nowuseeme.setEffect(shadow);
            
            infoProcess1.setVisible(true);
            infoProcess2.setVisible(true);
            infoSemaphores.setVisible(true); 
            
    
        });

        nowuseeme.setOnMouseExited(evt -> {           
            
            nowuseeme.setEffect(null);
            
            infoProcess1.setVisible(false);
            infoProcess2.setVisible(false);
            infoSemaphores.setVisible(false); 
    
        });
                                             
//---------------------
        
        root.getChildren().addAll(imageBackground);
        root.getChildren().addAll(tSemaphore, tSemaphoreN);       
        root.getChildren().addAll(cat1Going, cat2Returning, cat2Going, cat1Returning);
        root.getChildren().addAll(milkOutInit, milkOutGoing1, milkOutReturning1, milkOutGoing2, milkOutReturning2, locked1, locked2);
        root.getChildren().addAll(table1_0, table1_1, table1_2, table1_3, table2_0, table2_1, table2_2, table2_3, tProcess1, tProcess2);
        root.getChildren().addAll(btn1, btn2);
                
        for (int i = 0; i < 3; i++) {
            root.getChildren().addAll(data1.get(i), data2.get(i));
        }
           
        root.getChildren().addAll(infoProcess1, infoProcess2, infoSemaphores, nowuseeme);
                
        stage.setScene(scene);
        stage.setWidth(735);
        stage.setHeight(290);
        stage.show();
      
// BUTTONS ACTIONS
        
        btn1.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                
                cat1Use = true;
                
                btn1.setDisable(true);
                btn2.setDisable(true);
                
                table1_1.setVisible(true);
                
                // Cat 1 Going
                ft1Cat1Going.play();
                tCat1Going.play();
                stCat1Going.play();
                
                stCat1Going.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                    @Override 
                    public void handle(ActionEvent actionEvent) {
                        
                        if (cat2Use == false) btn2.setDisable(false);
                                                    
                        if (semaphore == 0){

                            cat1blocked = true;
                            locked1.setVisible(true);
     
                        }else returning1();
 
                    }
                }); 
            }
        });
        
        btn2.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {  
                 
                cat2Use = true;
                
                btn1.setDisable(true);
                btn2.setDisable(true);
                
                table2_1.setVisible(true);
                
                // Cat 2 Going
                ft1Cat2Going.play();
                tCat2Going.play();
                stCat2Going.play();
                
                stCat2Going.onFinishedProperty().set(new EventHandler<ActionEvent>() {
                    @Override 
                    public void handle(ActionEvent actionEvent) {     
                            
                       if (cat1Use == false)  btn1.setDisable(false);
                        
                        if (semaphore == 0){

                            cat2blocked = true;
                            locked2.setVisible(true);

                        }else returning2() ;  
                    }
                }); 
               
                
 
            }
        });
    }
    
    
// CAT 1 RETURNING
        
    public void returning1(){
        table1_1.setVisible(false);
        table1_2.setVisible(true);

        milkOutInit.setVisible(false);

        ft1Cat1Returning.play();
        tCat1Returning.play(); 
        stCat1Returning.play();

        ft1MilkOutReturning1.play();
        tMilkOutReturning1.play();
        stMilkOutReturning1.play();

        final SequentialTransition delay = new SequentialTransition (    
                new PauseTransition(Duration.millis(7000))
            ); 

        delay.onFinishedProperty().set(new EventHandler<ActionEvent>() {
            @Override 
            public void handle(ActionEvent actionEvent) {

                table1_2.setVisible(false);
                table1_3.setVisible(true);
                
                if (cat2Use == false) btn2.setDisable(true);

            }
        });

        delay.play();

        st1MilkOutGoing1.play();
        st2MilkOutGoing1.play();
        st3MilkOutGoing1.play();

        st2Cat1Going.play();
        st3Cat1Going.play();
        st5Cat1Going.play();

        st5Cat1Going.onFinishedProperty().set(new EventHandler<ActionEvent>() {
            @Override 
            public void handle(ActionEvent actionEvent) {

                milkOutInit.setVisible(true);
                semaphore++;
                tSemaphoreN.setText(Integer.toString(semaphore));
                
                cat1Use = false;               
                btn1.setDisable(false);                
                if (cat2Use == false) btn2.setDisable(false);
                
                cat1Going.setTranslateX(25);
                ft12Cat1Going.play();

                table1_3.setVisible(false);

                if (cat2blocked == true){

                  cat2blocked = false;
                  locked2.setVisible(false);
                  returning2();

                }

            }
        }); 

        semaphore--;
        tSemaphoreN.setText(Integer.toString(semaphore));

    }
    
// CAT 2 RETURNING
    
    public void returning2(){ 
        table2_1.setVisible(false);
        table2_2.setVisible(true);

        milkOutInit.setVisible(false);

        ft1Cat2Returning.play();
        tCat2Returning.play(); 
        stCat2Returning.play();

        ft1MilkOutReturning2.play();
        tMilkOutReturning2.play();
        stMilkOutReturning2.play();

        final SequentialTransition delay = new SequentialTransition (    
                new PauseTransition(Duration.millis(7000))
            ); 

        delay.onFinishedProperty().set(new EventHandler<ActionEvent>() {
            @Override 
            public void handle(ActionEvent actionEvent) {

                table2_2.setVisible(false);
                table2_3.setVisible(true);

                if (cat1Use == false) btn1.setDisable(true);
            }
        });

        delay.play();

        st1MilkOutGoing2.play();
        st2MilkOutGoing2.play();
        st3MilkOutGoing2.play();

        st2Cat2Going.play();
        st3Cat2Going.play();
        st5Cat2Going.play();

        st5Cat2Going.onFinishedProperty().set(new EventHandler<ActionEvent>() {
            @Override 
            public void handle(ActionEvent actionEvent) {

                milkOutInit.setVisible(true);
                semaphore++;
                tSemaphoreN.setText(Integer.toString(semaphore));
                
                cat2Use = false;
                btn2.setDisable(false);
                if (cat1Use == false) btn1.setDisable(false);

                cat2Going.setTranslateX(500);
                ft12Cat2Going.play();

                table2_3.setVisible(false);

                if (cat1blocked == true){

                  cat1blocked = false;
                  locked1.setVisible(false);
                  returning1();

                }

            }
        }); 

        semaphore--;
        tSemaphoreN.setText(Integer.toString(semaphore));

    }
    
    
    public static void main(String[] args) {
        launch(args);
    }
    
}